'From Squeak 2.4b of April 23, 1999 on 25 June 1999 at 10:10:04 pm'!
"Change Set:		SmallInterfaces GUI
Date:			25 June 1999
Author:			Masashi Umezawa
Version:	1.5
Distribution:	World

SmallInterfaces Squeak GUI. Developed from scratch for Squeak.

Original SmallInterfaces extension provides InterfaceBrowser for browsing interfaces. However, It is built on RefactoringBrowser. Since Refactoring
Browser in Squeak is not mature yet. I decided to develop tiny GUIs for Squeakers.

* InterfaceFinder
	You can navigate interfaces and implementing classes.

* InterfaceSettingPanel
	You can set default properties for SmallInterfaces. 

For closer information, please see class comments.
 
Copyright (C) 1999 Masashi Umezawa.

URL: http://brain.cs.uiuc.edu/VisualWorks.SmallInterfaces (original)
URL: http://www.mars.dti.ne.jp/~umejava/smalltalk/stClasses/smallinterfaces/ (Squeak Port)

"!

Model subclass: #InterfaceFinder
	instanceVariableNames: 'interfaceHome interfaceList interfaceListSelection classList classListSelection iMode cMode inMorphic '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmallInterfaces GUI'!
Model subclass: #InterfaceSettingPanel
	instanceVariableNames: 'configuration configEntryList configEntryListSelection '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmallInterfaces GUI'!

!InterfaceFinder commentStamp: '<historical>' prior: 0!

I can be used for finding defined interfaces in system.

I support:
* interface & class filtering
* create stubbed class & interface
* find interface implementing classes
* find interfaces implemented by classes

---
#creator
[:masashi | ^umezawa] 
#version 1.5 M.U 6/21/1999 23:17!

!InterfaceFinder methodsFor: 'initialize-release' stamp: 'M.U 6/21/1999 23:17'!
initialize
	inMorphic := false.
	interfaceHome := Interface home.
	self filterAllInterfaces.! !

!InterfaceFinder methodsFor: 'actions' stamp: 'M.U 6/19/1999 22:55'!
browseClass
	| cls |
	cls := self environment at: self classListSelection ifAbsent:[^self].
	Browser newOnClass: cls.! !

!InterfaceFinder methodsFor: 'actions' stamp: 'M.U 6/20/1999 00:15'!
browseClassDefinition
	| cls |
	cls := self environment at: self classListSelection ifAbsent:[^self].
	self privBrowseDefinitionOf: cls
	
	! !

!InterfaceFinder methodsFor: 'actions' stamp: 'M.U 6/19/1999 23:21'!
browseClassRepertoire
	| cls |
	cls := self environment at: self classListSelection ifAbsent:[^self].
	self privBrowseRepertoireOf: cls.
	! !

!InterfaceFinder methodsFor: 'actions' stamp: 'M.U 6/19/1999 22:55'!
browseInterface
	| if |
	if := self environment at: self interfaceListSelection ifAbsent:[^self].
	Browser newOnClass: if.! !

!InterfaceFinder methodsFor: 'actions' stamp: 'M.U 6/20/1999 00:16'!
browseInterfaceDefinition
	| if |
	if := self environment at: self interfaceListSelection ifAbsent:[^self].
	self privBrowseDefinitionOf: if
	
	! !

!InterfaceFinder methodsFor: 'actions' stamp: 'M.U 6/19/1999 23:19'!
browseInterfaceRepertoire
	| if |
	if := self environment at: self interfaceListSelection ifAbsent:[^self].
	self privBrowseRepertoireOf: if.
	! !

!InterfaceFinder methodsFor: 'actions' stamp: 'M.U 6/21/1999 23:51'!
createStubClass
	| if defaultStubClassName defaultSuperClassName stubClassName superClassName superClass cls sz arr |
	if := self environment at: self interfaceListSelection ifAbsent: [^ self].
	defaultStubClassName := if defaultClassName.
	defaultSuperClassName := #Object.
	stubClassName := self defaultDialogClass request: 'enter stub class name' initialAnswer: defaultStubClassName.
	stubClassName isEmpty ifTrue: [stubClassName := defaultStubClassName].
	superClassName := self defaultDialogClass request: ' enter superclass name' initialAnswer: defaultSuperClassName.
	superClassName isEmpty ifTrue: [superClassName := defaultSuperClassName].
	(stubClassName isEmpty or: [superClassName isEmpty])
		ifTrue: [^ self].
	superClass := self environment at: superClassName asSymbol ifAbsent: [^ self].
	self defaultInformerClass informUser: 'Creating...' during: [cls := if asClassNamed: stubClassName asSymbol super: superClass].
	sz := self classList size.
	arr := Array new: sz + 1.
	1 to: sz do: [:idx | arr at: idx put: (self classList at: idx)].
	arr at: sz + 1 put: cls name.
	self classList: arr.! !

!InterfaceFinder methodsFor: 'actions' stamp: 'M.U 6/21/1999 23:52'!
createStubInterface
	| cls defaultStubInterfaceName  stubInterfaceName if sz arr |
	cls := self environment at: self classListSelection ifAbsent: [^ self].
	defaultStubInterfaceName := cls defaultInterfaceName.
	stubInterfaceName := self defaultDialogClass request: 'enter stub interface name' initialAnswer: defaultStubInterfaceName.
	(stubInterfaceName isEmpty) ifTrue:[^self].
	self defaultInformerClass informUser: 'Creating...' during: [if := cls asInterfaceNamed: stubInterfaceName asSymbol].
	sz := self interfaceList size.
	arr := Array new: sz + 1.
	1 to: sz do: [:idx | arr at: idx put: (self interfaceList at: idx)].
	arr at: sz + 1 put: if name.
	self interfaceList: arr.! !

!InterfaceFinder methodsFor: 'actions' stamp: 'M.U 6/20/1999 01:40'!
filterAllClasses
	self classList: (self classStringArrayFrom: self environment allNonInterfaceClasses).
	self cMode: ''! !

!InterfaceFinder methodsFor: 'actions' stamp: 'M.U 6/20/1999 01:37'!
filterAllInterfaces
	self interfaceList: (self classStringArrayFrom: self interfaceHome allInterfaces).
	self iMode: ''! !

!InterfaceFinder methodsFor: 'actions' stamp: 'M.U 6/20/1999 02:17'!
filterAllSubclasses
	self privDialogFilterClassesUsing: [:cls | cls allSubclasses]. ! !

!InterfaceFinder methodsFor: 'actions' stamp: 'M.U 6/20/1999 01:56'!
filterCategoryNamedClasses
	| categoryName categoryStrings clsStrings |
	categoryName := self defaultDialogClass request: 'enter category name' initialAnswer: '*'.
	categoryStrings := (SystemOrganization categories select: [:each | categoryName match: each]).
	clsStrings := OrderedCollection new: (categoryStrings size * 4).
	categoryStrings do:[:each | clsStrings addAll: (SystemOrganization listAtCategoryNamed: each)].
	self classList: clsStrings.
	self cMode: ''! !

!InterfaceFinder methodsFor: 'actions' stamp: 'M.U 6/20/1999 01:37'!
filterExtendedInterfaces
	self interfaceList: (self classStringArrayFrom: self interfaceHome allExtendedInterfaces).
	self iMode: ''! !

!InterfaceFinder methodsFor: 'actions' stamp: 'M.U 6/20/1999 01:37'!
filterExtendingInterfaces
	self interfaceList: (self classStringArrayFrom: self interfaceHome allExtendingInterfaces).
	self iMode: ''! !

!InterfaceFinder methodsFor: 'actions' stamp: 'M.U 6/20/1999 01:37'!
filterLeafInterfaces
	self interfaceList: (self classStringArrayFrom: self interfaceHome leafInterfaces).
	self iMode: ''! !

!InterfaceFinder methodsFor: 'actions' stamp: 'M.U 6/20/1999 01:37'!
filterRootInterfaces
	self interfaceList: (self classStringArrayFrom: self interfaceHome rootInterfaces).
	self iMode: ''! !

!InterfaceFinder methodsFor: 'actions' stamp: 'M.U 6/20/1999 02:16'!
filterSubclasses
	self privDialogFilterClassesUsing: [:cls | cls subclasses].! !

!InterfaceFinder methodsFor: 'actions' stamp: 'M.U 6/20/1999 02:19'!
filterSuperclasses
	self privDialogFilterClassesUsing: [:cls | cls allSuperclasses].! !

!InterfaceFinder methodsFor: 'actions' stamp: 'M.U 6/21/1999 23:20'!
forceInMorphic
	self inMorphic: true! !

!InterfaceFinder methodsFor: 'actions' stamp: 'M.U 6/20/1999 01:13'!
listImplementedInterfaces
	| cls |
	cls := self environment at: self classListSelection ifAbsent:[^self].
	self interfaceList: (self classStringArrayFrom: cls implementedInterfaces).
	self iMode: #implementedInterfaces.! !

!InterfaceFinder methodsFor: 'actions' stamp: 'M.U 6/20/1999 01:13'!
listImplementedInterfacesMinimalSet
	| cls |
	cls := self environment at: self classListSelection ifAbsent:[^self].
	self interfaceList: (self classStringArrayFrom: cls implementedInterfacesMinimalSet).
	self iMode: #implementedInterfacesMinimalSet.! !

!InterfaceFinder methodsFor: 'actions' stamp: 'M.U 6/20/1999 01:14'!
listImplementingClasses
	| if |
	if := self environment at: self interfaceListSelection ifAbsent:[^self].
	self classList: (self classStringArrayFrom: if implementors).
	self cMode: #implementingClasses! !

!InterfaceFinder methodsFor: 'actions' stamp: 'M.U 6/20/1999 01:14'!
listUnderstandingClasses
	| if |
	if := self environment at: self interfaceListSelection ifAbsent:[^self].
	self classList: (self classStringArrayFrom: if understanders).
	self cMode: #understandingClasses! !

!InterfaceFinder methodsFor: 'actions' stamp: 'M.U 6/19/1999 19:42'!
perform: menuCallBack orSendTo: otherTarget 
	
	self  perform: menuCallBack.
	! !

!InterfaceFinder methodsFor: 'actions' stamp: 'M.U 6/20/1999 01:08'!
popClassFilterMenu
	| menu selector |
	menu := self defaultMenuClass new addList: self class classFilterMenuArray.
	menu title: 'class filter'.
	selector := menu startUp.
	selector isNil ifFalse: [self perform: selector].! !

!InterfaceFinder methodsFor: 'actions' stamp: 'M.U 6/20/1999 01:08'!
popInterfaceFilterMenu
	| menu selector |
	menu := self defaultMenuClass new addList: self class interfaceFilterMenuArray.
	menu title: 'interface filter'.
	selector := menu startUp.
	selector isNil ifFalse: [self perform: selector].! !

!InterfaceFinder methodsFor: 'menu constants' stamp: 'M.U 6/19/1999 15:36'!
classMenuTitle
	^self class classMenuTitle! !

!InterfaceFinder methodsFor: 'menu constants' stamp: 'M.U 6/19/1999 15:37'!
interfaceMenuTitle
	^self class interfaceMenuTitle! !

!InterfaceFinder methodsFor: 'list menu creation' stamp: 'M.U 6/21/1999 23:07'!
classListMenu: aCustomMenu 
	^self privBuildMenu: aCustomMenu with: self class classListMenuArray! !

!InterfaceFinder methodsFor: 'list menu creation' stamp: 'M.U 6/21/1999 23:07'!
interfaceListMenu: aCustomMenu 
	^self privBuildMenu: aCustomMenu with: self class interfaceListMenuArray.! !

!InterfaceFinder methodsFor: 'self update' stamp: 'M.U 6/20/1999 01:13'!
updateClassList
	self classList: #().
	self cMode == #implementingClasses ifTrue: [self listImplementingClasses].
	self cMode == #understandingClasses ifTrue: [self listUnderstandingClasses].! !

!InterfaceFinder methodsFor: 'self update' stamp: 'M.U 6/20/1999 01:13'!
updateInterfaceList
	self interfaceList: #().
	self iMode == #implementedInterfaces ifTrue: [self listImplementedInterfaces].
	self iMode == #implementedInterfacesMinimalSet ifTrue: [self listImplementedInterfacesMinimalSet].
	! !

!InterfaceFinder methodsFor: 'change notification' stamp: 'M.U 6/19/1999 23:44'!
classListSelectionChanged
	self changed: #classListSelection.
	self updateInterfaceList.
	
	! !

!InterfaceFinder methodsFor: 'change notification' stamp: 'M.U 6/19/1999 19:52'!
interfaceListSelectionChanged
	self changed: #interfaceListSelection.
	self updateClassList.
	! !

!InterfaceFinder methodsFor: 'factory' stamp: 'M.U 6/19/1999 23:34'!
defaultDialogClass
	^FillInTheBlank! !

!InterfaceFinder methodsFor: 'factory' stamp: 'M.U 6/20/1999 00:13'!
defaultEditorClass
	^Workspace! !

!InterfaceFinder methodsFor: 'factory' stamp: 'M.U 6/20/1999 02:23'!
defaultInformerClass
	^Utilities! !

!InterfaceFinder methodsFor: 'factory' stamp: 'M.U 6/19/1999 18:03'!
defaultMenuClass
	^CustomMenu! !

!InterfaceFinder methodsFor: 'factory' stamp: 'M.U 6/19/1999 22:54'!
environment
	^Smalltalk! !

!InterfaceFinder methodsFor: 'accessing' stamp: 'M.U 6/20/1999 00:38'!
cMode

	^cMode! !

!InterfaceFinder methodsFor: 'accessing' stamp: 'M.U 6/20/1999 00:46'!
cMode: aSymbol

	cMode := aSymbol.
	self changed: #cMode.! !

!InterfaceFinder methodsFor: 'accessing' stamp: 'M.U 6/19/1999 14:55'!
classList

	^classList! !

!InterfaceFinder methodsFor: 'accessing' stamp: 'M.U 6/19/1999 18:23'!
classList: aValue

	classList := aValue.
	self changed: #classList.! !

!InterfaceFinder methodsFor: 'accessing' stamp: 'M.U 6/19/1999 14:55'!
classListSelection

	^classListSelection! !

!InterfaceFinder methodsFor: 'accessing' stamp: 'M.U 6/19/1999 19:47'!
classListSelection: aValue

	classListSelection := aValue.
	self classListSelectionChanged.
	! !

!InterfaceFinder methodsFor: 'accessing' stamp: 'M.U 6/21/1999 23:16'!
forceInMorphic: aBolean

	forceInMorphic := aBolean.
	! !

!InterfaceFinder methodsFor: 'accessing' stamp: 'M.U 6/20/1999 00:38'!
iMode

	^iMode! !

!InterfaceFinder methodsFor: 'accessing' stamp: 'M.U 6/20/1999 00:47'!
iMode: aSymbol

	iMode := aSymbol.
	self changed: #iMode! !

!InterfaceFinder methodsFor: 'accessing' stamp: 'M.U 6/21/1999 23:18'!
inMorphic
	^inMorphic! !

!InterfaceFinder methodsFor: 'accessing' stamp: 'M.U 6/21/1999 23:19'!
inMorphic: aBoolean
	inMorphic := aBoolean! !

!InterfaceFinder methodsFor: 'accessing' stamp: 'M.U 6/19/1999 15:04'!
interfaceHome

	^interfaceHome! !

!InterfaceFinder methodsFor: 'accessing' stamp: 'M.U 6/19/1999 15:04'!
interfaceHome: aValue

	interfaceHome := aValue! !

!InterfaceFinder methodsFor: 'accessing' stamp: 'M.U 6/19/1999 14:56'!
interfaceList

	^interfaceList! !

!InterfaceFinder methodsFor: 'accessing' stamp: 'M.U 6/19/1999 18:23'!
interfaceList: aValue

	interfaceList := aValue.
	self changed: #interfaceList.! !

!InterfaceFinder methodsFor: 'accessing' stamp: 'M.U 6/19/1999 14:56'!
interfaceListSelection

	^interfaceListSelection! !

!InterfaceFinder methodsFor: 'accessing' stamp: 'M.U 6/19/1999 19:47'!
interfaceListSelection: aValue

	interfaceListSelection := aValue.
	self interfaceListSelectionChanged.! !

!InterfaceFinder methodsFor: 'private' stamp: 'M.U 6/19/1999 19:43'!
classStringArrayFrom: aCollectionOfClass
	^(aCollectionOfClass collect: [:each | each name]) asArray.! !

!InterfaceFinder methodsFor: 'private' stamp: 'M.U 6/20/1999 00:15'!
privBrowseDefinitionOf: aClassOrInterface
	| editor |
	editor := self defaultEditorClass new.
	editor contents: aClassOrInterface definitionWithInterfaces.
	editor openLabel: aClassOrInterface name. ' definition' 
	
	! !

!InterfaceFinder methodsFor: 'private' stamp: 'M.U 6/19/1999 23:20'!
privBrowseRepertoireOf: aClassOfInterface
	| menu selectors result |
	menu := self defaultMenuClass new.
	selectors := aClassOfInterface repertoire collect:[ :each | Array with: each with:each].
	menu addList: selectors.
	result := menu startUpWithCaption: 'repertoire'.
	result isNil ifFalse:[ Browser newOnClass: aClassOfInterface selector: result] 
	! !

!InterfaceFinder methodsFor: 'private' stamp: 'M.U 6/21/1999 23:23'!
privBuildMenu: aCustomMenu with: aMenuArray
	"Morhic should supoort #- syntax!! M.U 6/21/1999 23:06"
	(self environment isMorphic or: [self inMorphic])
		ifTrue: [aMenuArray do: [:each | each == #-
					ifTrue: [aCustomMenu addLine]
					ifFalse: [aCustomMenu add: each first action: each last]]]
		ifFalse: [aCustomMenu addList: aMenuArray].
	^aCustomMenu! !

!InterfaceFinder methodsFor: 'private' stamp: 'M.U 6/20/1999 02:18'!
privDialogFilterClassesUsing: aQueryBlock
	| ans className cls |
	ans := self classListSelection isNil
				ifTrue: ['']
				ifFalse: [self classListSelection].
	className := self defaultDialogClass request: 'enter class name' initialAnswer: ans.
	cls := self environment at: className asSymbol ifAbsent: [^ self].
	self classList: (self classStringArrayFrom: (aQueryBlock value: cls)).
	self cMode: ''.! !


!InterfaceFinder class methodsFor: 'interface opening' stamp: 'M.U 6/21/1999 22:54'!
open
	"InterfaceFinder open"
	World isNil
		ifTrue: [self openAsMVC]
		ifFalse: [self openAsMorph].! !

!InterfaceFinder class methodsFor: 'interface opening' stamp: 'M.U 6/21/1999 23:12'!
openAsMVC
	"InterfaceFinder openAsMVC"
	"# model init"
	| model interfaceButtonView interfaceModeView interfaceListView classButtonView classModeView classListView interfaceView classView topView |
	model := self new.
	"# build parts"
	interfaceButtonView := self
				buildMenuButtonViewBy: PluggableButtonView
				label: 'Interfaces'
				action: [model popInterfaceFilterMenu].
	interfaceModeView := self buildPluggableInterfaceModeViewBy: PluggableTextView on: model.
	interfaceListView := self buildPluggableInterfaceListViewBy: PluggableListViewByItem on: model.
	classButtonView := self
				buildMenuButtonViewBy: PluggableButtonView
				label: 'Classes'
				action: [model popClassFilterMenu].
	classModeView := self buildPluggableClassModeViewBy: PluggableTextView on: model.
	classListView := self buildPluggableClassListViewBy: PluggableListViewByItem on: model.
	"# set parts border & size"
	interfaceButtonView borderWidth: 1;
	 window: (0 @ 0 corner: 100 @ 14).
	interfaceModeView borderWidth: 1;
	 window: (0 @ 0 corner: 100 @ 8).
	interfaceListView borderWidth: 1;
	 window: (0 @ 0 corner: 100 @ 78).
	classButtonView borderWidth: 1;
	 window: (0 @ 0 corner: 100 @ 14).
	classModeView borderWidth: 1;
	 window: (0 @ 0 corner: 100 @ 8).
	classListView borderWidth: 1;
	 window: (0 @ 0 corner: 100 @ 78).
	"# coloring"
	interfaceButtonView backgroundColor: Color yellow.
	interfaceModeView backgroundColor: Color gray.
	classButtonView backgroundColor: Color red.
	classModeView backgroundColor: Color gray.
	"# assembling"
	interfaceView := View new model: model.
	interfaceView addSubView: interfaceButtonView;
	 addSubView: interfaceListView below: interfaceButtonView;
	 addSubView: interfaceModeView below: interfaceListView.
	classView := View new model: model.
	classView addSubView: classButtonView;
	 addSubView: classListView below: classButtonView;
	 addSubView: classModeView below: classListView.
	interfaceModeView controller: ReadOnlyTextController new.
	classModeView controller: ReadOnlyTextController new.
	topView := StandardSystemView new label: self name;
			 minimumSize: 200 @ 100;
			 addSubView: interfaceView;
			 addSubView: classView toRightOf: interfaceView.
	topView borderWidth: 5.
	topView controller open.! !

!InterfaceFinder class methodsFor: 'interface opening' stamp: 'M.U 6/21/1999 23:46'!
openAsMorph
	"InterfaceFinder openAsMorph openInMVC"
	"# model init"
	| model interfaceButtonView interfaceModeView interfaceListView classButtonView classModeView classListView window |
	model := self new forceInMorphic.
	"# build parts"
	interfaceButtonView := self
				buildMenuButtonViewBy: PluggableButtonMorph
				label: 'Interfaces'
				action: [model popInterfaceFilterMenu].
	interfaceModeView := self buildPluggableInterfaceModeViewBy: PluggableTextMorph on: model.
	interfaceListView := self buildPluggableInterfaceListViewBy: PluggableListMorphByItem on: model.
	classButtonView := self
				buildMenuButtonViewBy: PluggableButtonMorph
				label: 'Classes'
				action: [model popClassFilterMenu].
	classModeView := self buildPluggableClassModeViewBy: PluggableTextMorph on: model.
	classListView := self buildPluggableClassListViewBy: PluggableListMorphByItem on: model.
	"# coloring"
	interfaceButtonView onColor: Color gray offColor: Color yellow.
	interfaceModeView color: Color gray.
	classButtonView onColor: Color gray offColor: Color red.
	classModeView color: Color gray.
	"# assembling"
	window := (SystemWindow labelled: self name) model: model;
			 addMorph: interfaceButtonView frame: (0.0 @ 0.0 extent: 0.5 @ 0.1);
			 addMorph: interfaceListView frame: (0.0 @ 0.1 extent: 0.5 @ 0.9);
			 addMorph: interfaceModeView frame: (0.0 @ 0.9 extent: 0.5 @ 0.1);
			 addMorph: classButtonView frame: (0.5 @ 0.0 extent: 0.5 @ 0.1);
			 addMorph: classListView frame: (0.5 @ 0.1 extent: 0.5 @ 0.9);
			 addMorph: classModeView frame: (0.5 @ 0.9 extent: 0.5 @ 0.1).
	window borderWidth: 5.
	window openInWorldExtent: 500@250.
	^ window.! !

!InterfaceFinder class methodsFor: 'instance creation' stamp: 'M.U 6/19/1999 14:56'!
new
	^super new initialize! !

!InterfaceFinder class methodsFor: 'builder' stamp: 'M.U 6/19/1999 16:38'!
buildMenuButtonViewBy: aViewClass action: anActionBlock
	| view button |
	button := Button new.
	button onAction: anActionBlock.
	view := aViewClass on: button.
	^view! !

!InterfaceFinder class methodsFor: 'builder' stamp: 'M.U 6/19/1999 17:25'!
buildMenuButtonViewBy: aViewClass label: aString action: anActionBlock
	| view button |
	button := Button new.
	button onAction: anActionBlock.
	view := aViewClass on: button.
	view label: aString.
	^view! !

!InterfaceFinder class methodsFor: 'builder' stamp: 'M.U 6/19/1999 16:26'!
buildPluggableClassListViewBy: aViewClass on: aModel
	| view |
	view := aViewClass on: aModel
			list: #classList
			selected: #classListSelection
			changeSelected: #classListSelection:
			menu: #classListMenu:.
	view  menuTitleSelector: #classMenuTitle.
	^view! !

!InterfaceFinder class methodsFor: 'builder' stamp: 'M.U 6/20/1999 01:11'!
buildPluggableClassModeViewBy: aViewClass on: aModel
	| view |
	view := aViewClass on: aModel
			text: #cMode
			accept: #cMode:.
	^view! !

!InterfaceFinder class methodsFor: 'builder' stamp: 'M.U 6/19/1999 16:26'!
buildPluggableInterfaceListViewBy: aViewClass on: aModel
	| view |
	view := aViewClass on: aModel
			list: #interfaceList
			selected: #interfaceListSelection
			changeSelected: #interfaceListSelection:
			menu: #interfaceListMenu:.
	view  menuTitleSelector: #interfaceMenuTitle.
	^view! !

!InterfaceFinder class methodsFor: 'builder' stamp: 'M.U 6/20/1999 01:11'!
buildPluggableInterfaceModeViewBy: aViewClass on: aModel
	| view |
	view := aViewClass on: aModel
			text: #iMode
			accept: #iMode:.
	^view! !

!InterfaceFinder class methodsFor: 'menu arrays' stamp: 'M.U 6/20/1999 02:04'!
classFilterMenuArray
	^#(
	('all classes' #filterAllClasses)
	('classes in category named...' #filterCategoryNamedClasses)
	('subclasses of...' #filterSubclasses)
	('all subclasses of...' #filterAllSubclasses)
	('superclasses of...' #filterSuperclasses)
	)! !

!InterfaceFinder class methodsFor: 'menu arrays' stamp: 'M.U 6/20/1999 00:27'!
classListMenuArray
	^#(
	('browse' #browseClass)
	('repertoire' #browseClassRepertoire)
	('definition' #browseClassDefinition)
	-
	('implemented interfaces' #listImplementedInterfaces)
	('implemented interfaces minimal set' #listImplementedInterfacesMinimalSet)
	-
	('create stub interface' #createStubInterface)
	)! !

!InterfaceFinder class methodsFor: 'menu arrays' stamp: 'M.U 6/19/1999 22:58'!
interfaceFilterMenuArray
	^#(
	('all interfaces' #filterAllInterfaces)
	('root interfaces' #filterRootInterfaces)
	('leaf interfaces' #filterLeafInterfaces)
	('extended interfaces' #filterExtendedInterfaces)
	('extending interfaces' #filterExtendingInterfaces)
	)! !

!InterfaceFinder class methodsFor: 'menu arrays' stamp: 'M.U 6/20/1999 00:18'!
interfaceListMenuArray
	^#(
	('browse' #browseInterface)
	('repertoire' #browseInterfaceRepertoire)
	('definition' #browseInterfaceDefinition)
	-
	('implementors' #listImplementingClasses)
	('understanders' #listUnderstandingClasses)
	-
	('create stub class' #createStubClass)
	)! !

!InterfaceFinder class methodsFor: 'constants' stamp: 'M.U 6/19/1999 15:13'!
classMenuTitle
	^'Class menu'! !

!InterfaceFinder class methodsFor: 'constants' stamp: 'M.U 6/19/1999 15:13'!
interfaceMenuTitle
	^'Interface menu'! !


!InterfaceSettingPanel commentStamp: '<historical>' prior: 0!

Below properties can be set:

* defaultInterfaceClassCategory  <String> ('Interfaces') indicates the interface default directory
* enforceNonEmptyInterfaces <Boolean> (true)  if true, empty interface is not allowed
* removeOnlyStubbedImplementations <Boolean> (true) if true, only stubbed methods will be removed
* selectorForInterfaceInheritance <Symbol> (#parents) which interfaces should be shown in the definition string
* selectorForClassInterfaces <Symbol> (#understoodInterfacesMinimalSet) which interfaces should be shown in the definition string

---
#creator
[:masashi | ^umezawa] 
#version 1.5 M.U 6/21/1999 23:17!

!InterfaceSettingPanel methodsFor: 'initialize-release' stamp: 'M.U 6/19/1999 15:02'!
initialize
	configuration := Interface configuration.
	configEntryList := self class configurationEntryList.
	! !

!InterfaceSettingPanel methodsFor: 'selection changed'!
configEntryListSelection: anSelection

	configEntryListSelection := anSelection.
	self changed: #configEntryListSelection.
	self changed: #configEntryValue.! !

!InterfaceSettingPanel methodsFor: 'actions'!
configEntryValue
	self configEntryListSelection isNil ifTrue:[^''].
	^(self configuration perform: (self configEntryListSelection asSymbol) ) printString.! !

!InterfaceSettingPanel methodsFor: 'actions' stamp: 'M.U 6/19/1999 15:05'!
perform: menuCallBack orSendTo: otherTarget 
	| value |
	value := menuCallBack == #fillInTheBlank
				ifTrue: [FillInTheBlank request: 'value?']
				ifFalse: [menuCallBack].
	value == #true ifTrue: [value := true].
	value == #false ifTrue: [value := false].
	self configuration perform: (self configEntryListSelection , ':') asSymbol with: value.
	self changed: #configEntryValue.! !

!InterfaceSettingPanel methodsFor: 'menu constants' stamp: 'M.U 6/19/1999 15:35'!
configMenuTitle
	^self class configMenuTitle! !

!InterfaceSettingPanel methodsFor: 'list menu creation'!
configEntryMenu: aCustomMenu 
	| menuArrGetSelector |
	menuArrGetSelector := self configEntryListSelection , 'MenuArray'.
	^ aCustomMenu addList: (self class perform: menuArrGetSelector asSymbol).! !

!InterfaceSettingPanel methodsFor: 'accessing'!
configEntryList

	^configEntryList! !

!InterfaceSettingPanel methodsFor: 'accessing'!
configEntryList: aValue
	
	configEntryList := aValue.
	! !

!InterfaceSettingPanel methodsFor: 'accessing'!
configEntryListSelection

	^configEntryListSelection! !

!InterfaceSettingPanel methodsFor: 'accessing'!
configuration

	^configuration! !

!InterfaceSettingPanel methodsFor: 'accessing'!
configuration: aValue

	configuration := aValue! !


!InterfaceSettingPanel class methodsFor: 'interface opening' stamp: 'M.U 6/18/1999 23:59'!
open
	"InterfaceSettingPanel open"
	World isNil
		ifTrue: [self openAsMVC]
		ifFalse: [self openAsMorph].! !

!InterfaceSettingPanel class methodsFor: 'interface opening' stamp: 'M.U 6/21/1999 00:24'!
openAsMVC
	"InterfaceSettingPanel openAsMVC"

	| model enrtyView  valueView topView |
	model := self new.
	enrtyView :=
		PluggableListViewByItem on: model
			list: #configEntryList
			selected: #configEntryListSelection
			changeSelected: #configEntryListSelection:
			menu: #configEntryMenu:.
	enrtyView  menuTitleSelector: #configMenuTitle.
	valueView :=
		PluggableTextView on: model
			text: #configEntryValue
			accept: #configEntryValue:.
	valueView controller: ReadOnlyTextController new.
	topView := StandardSystemView new
		label: self name;
		minimumSize: 300@200;
		addSubView: enrtyView;
		addSubView: valueView toRightOf: enrtyView.
		
	topView borderWidth: 5.
	topView controller open.! !

!InterfaceSettingPanel class methodsFor: 'interface opening' stamp: 'M.U 6/21/1999 23:48'!
openAsMorph
	"InterfaceSettingPanel openAsMorph openInMVC"

	| model enrtyMorph valueMorph window |
	model _ self new.
	enrtyMorph :=
		PluggableListMorphByItem on: model
			list: #configEntryList
			selected: #configEntryListSelection
			changeSelected: #configEntryListSelection:
			menu: #configEntryMenu:.
	enrtyMorph  menuTitleSelector: #configMenuTitle.
	valueMorph _
		PluggableTextMorph on: model
			text: #configEntryValue
			accept: #configEntryValue:.
	
	window := (SystemWindow 
		labelled: self name) model: model.
	window addMorph: enrtyMorph frame: (0@0 corner: 0.5@1).
	window addMorph: valueMorph frame: (0.5@0 corner: 1@1).	
	window borderWidth: 5.
	window openInWorldExtent: 400@200.
	^window! !

!InterfaceSettingPanel class methodsFor: 'instance creation'!
new
	^super new initialize! !

!InterfaceSettingPanel class methodsFor: 'constants'!
configMenuTitle
	^'choose them'! !

!InterfaceSettingPanel class methodsFor: 'constants'!
configurationEntryList
	^#(enforceNonEmptyInterfaces removeOnlyStubbedImplementations selectorForInterfaceInheritance selectorForClassInterfaces defaultInterfaceClassCategory )! !

!InterfaceSettingPanel class methodsFor: 'constants'!
helpString

	^'SmallInterfaces Configuration Setup

Set the preferences for system-wide behavior of interfaces.

Enforce Non EmptyInterfaces 
	- is an empty interface legal?

Remove Only Stubbed Implementations
	- when unimplementing an interface for a class, which parts of the implementation should be removed?  

Selector for Interface Inheritance
	- which interfaces should be shown in the definition string?

Selector for Class Interfaces
	- which interfaces should be shown in the definition string?
'! !

!InterfaceSettingPanel class methodsFor: 'menu arrays'!
defaultInterfaceClassCategoryMenuArray
	^#(
	('Interfaces(default)' 'Interfaces')
	('others' #fillInTheBlank)
	)! !

!InterfaceSettingPanel class methodsFor: 'menu arrays'!
enforceNonEmptyInterfacesMenuArray
	^#(
	('true(default)' true)
	('false' false)
	)! !

!InterfaceSettingPanel class methodsFor: 'menu arrays'!
removeOnlyStubbedImplementationsMenuArray
	^#(
	('true(default)' true)
	('false' false)
	)! !

!InterfaceSettingPanel class methodsFor: 'menu arrays'!
selectorForClassInterfacesMenuArray
	^#(
	( 'implementedInterfaces' implementedInterfaces)
	( 'implementedInterfacesMinimalSet' implementedInterfacesMinimalSet)
	( 'understoodInterfaces' understoodInterfaces)
	( 'understoodInterfacesMinimalSet(default)' understoodInterfacesMinimalSet)
	)! !

!InterfaceSettingPanel class methodsFor: 'menu arrays'!
selectorForInterfaceInheritanceMenuArray
	^#(
	('parents(default)' parents)
	('ancestors' ancestors)
	('extendedInterface's extendedInterfaces)
	)! !


