'From Squeak 2.4b of April 23, 1999 on 25 June 1999 at 7:08:17 pm'!
"Change Set:		SmallInterfaces
Date:			25 June 1999
Porter:			Masashi Umezawa
Version:	1.5
Distribution:	World

SmallInterfaces Squeak Port. (core module) 
Originally developed by Benny Sadeh in VisualWorks 3.0 NC.

'SmallInterfaces' brings you long-awaited 'interface' in Smalltalk.
Please see Interface class >> documentaion protocol for details.


Copyright (C) 1999 Benny Sadeh.
Copyright (C) 1999 Masashi Umezawa.

URL: http://brain.cs.uiuc.edu/VisualWorks.SmallInterfaces (original)
URL: http://www.mars.dti.ne.jp/~umejava/smalltalk/stClasses/smallinterfaces/ (Squeak Port)

"!

Object subclass: #Interface
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmallInterfaces'!
Object subclass: #InterfaceConfiguration
	instanceVariableNames: 'enforceNonEmptyInterfaces removeOnlyStubbedImplementations selectorForInterfaceInheritance selectorForClassInterfaces defaultInterfaceClassCategory '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmallInterfaces'!
InterfaceConfiguration class
	instanceVariableNames: 'singleton '!
Object subclass: #InterfaceHome
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmallInterfaces'!
InterfaceHome class
	instanceVariableNames: 'singleton '!
Object subclass: #RepertoireHome
	instanceVariableNames: 'classRepertoiresDictionary '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SmallInterfaces'!
RepertoireHome class
	instanceVariableNames: 'singleton '!

!Object methodsFor: 'accessing'!
environment

	^self class environment! !

!Object methodsFor: 'accessing'!
starts: aSequenceableCollection
	"Answer whether the first element of aSequenceableCollection is equal to the receiver."

	^aSequenceableCollection first = self! !

!Object methodsFor: 'testing'!
conformsTo: anInterface
	"Can I respond to any message in <anInterface> repertoire?"

	^self class understands: anInterface! !

!Object methodsFor: 'testing'!
ends: aSequenceableCollection
	"Answer whether the last element of aSequenceableCollection is equal to the receiver."

	^aSequenceableCollection last = self! !

!Object methodsFor: 'testing'!
isClass
	"Answer whether the receiver is a class."

	^false! !

!Object methodsFor: 'testing'!
isCollection
	"Answer whether the receiver is an instance of a kind of Collection."

	^false! !

!Object methodsFor: 'testing'!
isInterface

	^false! !

!Object methodsFor: 'testing'!
isTypeOf: aClassOrInterface

	^aClassOrInterface isEmbodiedIn: self! !

!Object methodsFor: 'indicating'!
needsFurtherWork
	"Marks code that needs further work.
	It is assumed to be left 'in the middle' of developement."! !

!Object methodsFor: 'indicating'!
shouldImplementFor: anInterface 
	"This method is used to mark a method as one generated (and stubbed) for an interface."

	^anInterface implementorsResponsibility! !

!Object methodsFor: 'indicating'!
subclassesShouldOverride
	"Unlike #subclassResponsibility, this is a recommendation only."! !

!Object methodsFor: 'querying'!
types
	"Which are all the types which I embody?
	Definition: Type = (Class | Interface)"

	^self class allSuperclasses 
		addAll: self class understoodInterfaces;
		yourself! !


!Behavior methodsFor: 'accessing'!
environment
	"SmallInterfaces: ##added for Squeak -M.U. 6/23/1999 23:35"
	^Smalltalk! !

!Behavior methodsFor: 'accessing'!
methodDictionary
	"Answer the receiver's method dictionary"
	"SmallInterfaces: ##modified for Squeak -M.U. 6/23/1999 23:35"

	^self methodDict! !

!Behavior methodsFor: 'testing'!
specialSelectorIndexFor: selector
	"Private - Answer the special selector index for the vm."

	^CompiledMethod specialSelectorIndexFor: selector! !

!Behavior methodsFor: 'accessing method dictionary'!
>> selector
	"Answer the receiver's method named selector.
	 Error if the receiver does not define a method named selector."
	
	"SmallInterfaces: ##modified for Squeak -M.U. 6/23/1999 23:35"

	^self
		compiledMethodAt: selector
		ifAbsent: [self error: selector, 'is absent']! !

!Behavior methodsFor: 'accessing method dictionary'!
removeSelector: selector ifAbsent: exceptionHandler

	(self methodDictionary includesKey: selector) ifFalse: [^exceptionHandler value].
	^self removeSelector: selector! !


!ChangeSet methodsFor: 'change management' stamp: 'M.U 6/16/1999 00:57'!
changeClass: class 
	"Include indication that a class definition has been changed. 
	 6/10/96 sw: don't accumulate this information for classes that don't want logging
	 7/12/96 sw: use wantsChangeSetLogging flag"

	class wantsChangeSetLogging ifTrue: 
		[
			self atClass: class add: #change.
			self addCoherency: class name
		].

	"SmallInterfaces: ##added for Squeak -M.U. 6/23/1999 23:35"
	self class changed: class.
	! !

!ChangeSet methodsFor: 'change management' stamp: 'M.U 6/16/1999 00:42'!
noteRemovalOf: aClass
	"The class is about to be removed from the system.  Adjust the receiver to reflect that fact."

	classChanges removeKey: aClass name ifAbsent: [].
	methodChanges removeKey: aClass name ifAbsent: [].
	classChanges removeKey: aClass class name ifAbsent: [].
	methodChanges removeKey: aClass class name ifAbsent: [].
	classRemoves add: aClass name.
	
	"SmallInterfaces: ##added for Squeak -M.U. 6/23/1999 23:35"
	self class changed: aClass.! !

!ChangeSet methodsFor: 'change management' stamp: 'M.U 6/15/1999 00:50'!
removeClassAndMetaClassChanges: class
	"Remove all memory of changes associated with this class and its metaclass.  7/18/96 sw"

	classChanges removeKey: class name ifAbsent: [].
	methodChanges removeKey: class name ifAbsent: [].
	classChanges removeKey: class class name ifAbsent: [].
	methodChanges removeKey: class class name ifAbsent: [].
	classRemoves remove: class name ifAbsent: [].
	
	"SmallInterfaces: ##added for Squeak -M.U. 6/23/1999 23:35"
	self class changed: aClass.! !

!ChangeSet methodsFor: 'method changes' stamp: 'M.U 6/15/1999 00:49'!
addSelector: selector class: class 
	"Include indication that a method has been added.
	 5/16/96 sw: tell Utilities of the change so it can put up an in-order browser on recent submissions."

	Utilities noteMethodSubmission: selector forClass: class name.
	self atSelector: selector class: class put: #add.
	
	"SmallInterfaces: ##added for Squeak -M.U. 6/23/1999 23:35"
	self class changed: class.! !

!ChangeSet methodsFor: 'method changes' stamp: 'M.U 6/15/1999 00:50'!
removeSelector: selector class: class 
	"Include indication that a method has been forgotten."

	(self atSelector: selector class: class) = #add
		ifTrue: [self atSelector: selector
					class: class
					put: #addedThenRemoved]
		ifFalse: [self atSelector: selector
					class: class
					put: #remove].

	(class includesSelector: selector) ifTrue:
		["Save the source code pointer and category so can still browse old versions"
		methodRemoves at: (Array with: class name with: selector)
			put: (Array with: (class compiledMethodAt: selector) sourcePointer
						with: (class whichCategoryIncludesSelector: selector))].
	
	"SmallInterfaces: ##added for Squeak -M.U. 6/23/1999 23:35"
	self class changed: class.! !

!ChangeSet methodsFor: 'private' stamp: 'M.U 6/16/1999 00:44'!
atClass: class add: changeType

	(self isNew: class) ifFalse: 	"new classes don't matter"
		[(classChanges at: class name
				ifAbsent: [^classChanges at: class name put:
					(Set with: changeType)])
			add: changeType].

	"SmallInterfaces: ##added for Squeak -M.U. 6/23/1999 23:35"
	self class changed: class.! !


!ClassDescription methodsFor: 'organization'!
removeAllEmptyCategories

	self organization removeEmptyCategories! !

!ClassDescription methodsFor: 'querying'!
commentFor: selector
		"Return the comment entered for selector."

	"SmallInterfaces: ##modified for Squeak -M.U. 6/23/1999 23:35"

	| cm comments |
	cm := (self compiledMethodAt: selector ifAbsent: [^'']).
	comments := (Parser new) parseMethodComment: cm getSourceFromFile setPattern: [:x |]. "M.U. 6/23/1999 23:35"
	^comments notEmpty
		ifTrue: [comments first]
		ifFalse: ['']! !

!ClassDescription methodsFor: 'querying'!
selectorsInCategory: categoryName 

	Symbol 
		hasInterned: categoryName 
		ifTrue: [:sym | ^self organization listAtCategoryNamed: sym].
	^#()! !


!Class methodsFor: 'testing'!
isClass
	"Answer whether the receiver is a class."

	^true! !

!Class methodsFor: 'testing'!
isEmbodiedIn: anObject

	^anObject isKindOf: self! !

!Class methodsFor: 'subclass creation'!
subclass: className
	instanceVariableNames: stringOfInstVars
	classVariableNames: stringOfClassVars
	poolDictionaries: stringOfPoolNames
	category: category
 	interfaces: stringOfInterfaces
	"Create or modify class so it would adhere to the declared Interfaces."

	| class |
	class := self
		subclass: className
		instanceVariableNames: stringOfInstVars
		classVariableNames: stringOfClassVars
		poolDictionaries: stringOfPoolNames
		category: category.
	class implementInterfacesNamed: stringOfInterfaces.		
	^class! !

!Class methodsFor: 'subclass creation'!
variableByteSubclass: className
	instanceVariableNames: stringOfInstVars
	classVariableNames: stringOfClassVars
	poolDictionaries: stringOfPoolNames
	category: category
 	interfaces: stringOfInterfaces
	"Create or modify class so it would adhere to the declared Interfaces."

	| class |
	class := self
		variableByteSubclass: className
		instanceVariableNames: stringOfInstVars
		classVariableNames: stringOfClassVars
		poolDictionaries: stringOfPoolNames
		category: category.
	class implementInterfacesNamed: stringOfInterfaces.		
	^class! !

!Class methodsFor: 'subclass creation'!
variableSubclass: className
	instanceVariableNames: stringOfInstVars
	classVariableNames: stringOfClassVars
	poolDictionaries: stringOfPoolNames
	category: category
 	interfaces: stringOfInterfaces
	"Create or modify class so it would adhere to the declared Interfaces."

	| class |
	class := self
		variableSubclass: className
		instanceVariableNames: stringOfInstVars
		classVariableNames: stringOfClassVars
		poolDictionaries: stringOfPoolNames
		category: category.
	class implementInterfacesNamed: stringOfInterfaces.		
	^class! !

!Class methodsFor: 'documentation'!
requiredInterfaces
	"This method is a template which aims to facilitate documenting the interfaces a class should be able to understand.
	At that point the question <aBehavior understandsRequiredInterfaces> becomes meaningful."
	
	self subclassesShouldOverride.
	^#()! !

!Class methodsFor: 'documentation'!
understandsRequiredInterfaces
	"This method aims to help with design validation"
	
	^self requiredInterfaces
		inject: true
		into: 
			[:truth :interface |
			truth and: [self understands: interface]]! !

!Class methodsFor: 'message removal'!
discardExistingInterfacesNottIn: interfaces

self needsFurtherWork.	
"Since interfaces can overlap, we need to remove only the portion not overlapping.
for now, the following will do."

	self unimplementInterfaces: (self implementedInterfaces - interfaces)! !

!Class methodsFor: 'message removal'!
unimplementInterface: anInterface
	"Remove implementations for all of <anInterface> repertoire I already implement."

	self unimplementInterface: anInterface enforce: true! !

!Class methodsFor: 'message removal'!
unimplementInterface: anInterface enforce: enforcing
	"Remove all methods implemented on behalf of <anInterface>.
	If <enforcing>, remove my implementions of <anInterface>'s repetoire.
	If not, remove only the the stubbed implementations."

	| selectorsToBeRemoved |
	selectorsToBeRemoved := enforcing
		ifTrue: [anInterface methodsImplementedBy: self]
		ifFalse: [anInterface methodsStubbedIn: self].
	selectorsToBeRemoved do: [:each | self removeSelector: each ifAbsent: []].
	self removeAllEmptyCategories.! !

!Class methodsFor: 'message removal'!
unimplementInterfaces: interfaces

	interfaces do: 
		[:each | 
		self 
			unimplementInterface: each 
			enforce: (Interface configuration removeOnlyStubbedImplementations not)]! !

!Class methodsFor: 'interfaces'!
implementedInterfaces

	^Interface home allInterfaces select: [:each | self implements: each]! !

!Class methodsFor: 'interfaces'!
implementedInterfacesMinimalSet
	"What is the minimal set of interfaces which fully 
	describe the repertoire of all interfaces I implement?"
	
	^Interface consolidate: self implementedInterfaces! !

!Class methodsFor: 'interfaces'!
implements: anInterface
	"Do I directly implement all of <anInterface> repertoire?
	Note the difference between implementing and understanding."

	^anInterface isImplementedBy: self! !

!Class methodsFor: 'interfaces'!
understands: anInterface
	"Can my instances respond to all of <anInterface> repertoire?
	Note the difference between implementing and understanding."

	^anInterface isUnderstoodBy: self! !

!Class methodsFor: 'interfaces'!
understandsAll: collectionOfInterfaces
	"This method aims to help with design validation"
	
	^collectionOfInterfaces
		inject: true
		into: 
			[:truth :interface |
			truth and: [self understands: interface]]! !

!Class methodsFor: 'interfaces'!
understoodInterfaces

	^Interface home allInterfaces select: [:each | self understands: each]! !

!Class methodsFor: 'interfaces'!
understoodInterfacesMinimalSet
	"What is the minimal set of interfaces which fully 
	describe the repertoire of all interfaces I understand?"

	^Interface consolidate: self understoodInterfaces! !

!Class methodsFor: 'repertoire'!
repertoire
	"Note: the original implementation was - ^self allSelectors.
	However, since this was very slow, a new caching scheme can be used instead."

	^RepertoireHome current repertoireFor: self! !

!Class methodsFor: 'repertoire'!
repertoireImplemented

	^self selectors! !

!Class methodsFor: 'message generation'!
implementInterface: anInterface
	"Create implementations for all of <anInterface> methods which I do not understand yet."

	self implementInterface: anInterface enforce: false! !

!Class methodsFor: 'message generation'!
implementInterface: anInterface enforce: enforcing
	"Create methods implementations on behalf of <anInterface>.
	If <enforcing>, create implementations for all of <anInterface>'s repetoire (rather then merely 
	understand it). If not, create implementations only for the part I do not understand yet."

	| selectorsToBeImplemented |
	selectorsToBeImplemented := (enforcing or: [anInterface mustBeImplemented])
		ifTrue: [anInterface methodsNotImplementedBy: self]
		ifFalse: [anInterface methodsNotUnderstoodBy: self].
	selectorsToBeImplemented do: [:each | anInterface createStubbedMethodFor: each from: self]! !

!Class methodsFor: 'message generation'!
implementInterfaces: interfaces 

	interfaces do: [:each | self implementInterface: each]! !

!Class methodsFor: 'message generation'!
implementInterfaces: interfaces discardExisting: discarding
	"Create implementations for <interfaces>.
	If <discarding>, discard existing implementations of interfaces not in <interfaces>."

	discarding ifTrue: [self discardExistingInterfacesNottIn: interfaces].
	self implementInterfaces: interfaces.! !

!Class methodsFor: 'message generation'!
implementInterfacesNamed: stringOfInterfaces 

	self 
		implementInterfaces: (Interface interfacesFromString: stringOfInterfaces)
		discardExisting: true.! !

!Class methodsFor: 'interfaces creation'!
asInterface

	^self asInterfaceNamed: self defaultInterfaceName! !

!Class methodsFor: 'interfaces creation'!
asInterfaceNamed: aSymbol

	(Interface home includesInterfaceNamed: aSymbol) 
		ifTrue: [^self error: aSymbol asString, ' interface already exists!!'].

	^Interface newNamed: aSymbol from: self! !

!Class methodsFor: 'interfaces creation'!
defaultInterfaceName

	^(self name, 'Interface') asSymbol! !

!Class methodsFor: 'interfaces creation'!
implementationStringForInterface

	^String newLarge writeStream
		nextPutAll: '^self';
		space;
		nextPutAll: Interface selectorForImplementation asString;
		contents! !

!Class methodsFor: 'printing'!
definitionWithInterfaces 

	| writer classInterfacesSelector classInterfaces |
	writer := String newLarge writeStream.
	writer
		nextPutAll: self definition;
		crtab;
		nextPutAll: 'interfaces: ';
		nextPut: $'.
	classInterfacesSelector := Interface configuration selectorForClassInterfaces.
	classInterfaces := (self perform: classInterfacesSelector) asSortedCollection: Class sortBlock.
	classInterfaces do: [:each | writer nextPutAll: each name asString; space].
	writer nextPut: $'.
	^writer contents! !


!Class class methodsFor: 'sorting'!
sortBlock
		"Answer a sort block for sorting classes alphabetically."

	^[:a :b | a name <= b name]! !


!Collection methodsFor: 'testing'!
allSatisfy: aBlock 
	"Note that an empty collection will return true!!
	<'some' allSatisfy: [:each | each isCharacter]>
	<#() allSatisfy: [:each | each isNumber]>
	<'some' allSatisfy: [:each | each == true]>"
	
	^(self select: aBlock) includesAll: self! !

!Collection methodsFor: 'testing'!
consistsOf: aCollection 
	"Returns true if the contents of the receiver and <aCollection> 
	are exactly the same - order doesn't matter."

	^self size = aCollection size and: [self includesAllOccurrences: aCollection]! !

!Collection methodsFor: 'testing'!
includesAll: aCollection
	"Answer whether the receiver includes each element of aCollection."

	aCollection do: [:each | (self includes: each) ifFalse: [^false]].
	^true! !

!Collection methodsFor: 'testing'!
includesAllOccurrences: aCollection 
	"Return true if the receiver includes all elements in aCollection. 
	If aCollection contains duplicate elements, the receiver must have one for each of them."

	| meAsBag otherBag |
	aCollection size > self size ifTrue: [^false].
	otherBag := aCollection asBag.
	meAsBag := self asBag.
	otherBag do: [:each | (meAsBag occurrencesOf: each) < (otherBag occurrencesOf: each) ifTrue: [^false]].
	^true! !

!Collection methodsFor: 'testing'!
includesAny: aCollection
	"Return true if the receiver includes any of the elements in aCollection."

	aCollection do: [:each | (self includes: each) ifTrue: [^true]].
	^false! !

!Collection methodsFor: 'testing'!
isCollection
	"Answer whether the receiver is a <Collection>."

	^true! !

!Collection methodsFor: 'testing'!
notEmpty
	"Answer whether the receiver contains at least one element."

	^self isEmpty not! !

!Collection methodsFor: 'adding'!
, aCollection 
	"Answer a copy of the receiver agregated with the argument, aCollection."

	^self copy 
		addAll: aCollection;
		yourself! !

!Collection methodsFor: 'converting'!
flattened
	"Answer a new collection containing all my elements, flattened,
	which means: if an element is a collection, then flatten it as well (recursively).
	<#(1 #(2 3 4) #(10 #(12 13 14 #(#(100) 200 #(251 252) 300 400)))) flattened>"

	| newCollection |
	newCollection := self species new: self size.
	self do: 
		[:each | 
		each isCollection
			ifTrue: [newCollection addAll: each flattened]
			ifFalse: [newCollection add: each]].
	^newCollection! !

!Collection methodsFor: 'set operations'!
intersectionWith: anotherCollection
	"Return the elements in common with receiver and anotherCollection 
	as an appropriate collection with one instance of each element."

	^anotherCollection intersectionWithSet: self asSet! !

!Collection methodsFor: 'set operations'!
intersectionWithSet: aSet
	"Return the elements in common with receiver and anotherCollection 
	as an appropriate collection with one instance of each element."

	^self asSet intersectionWithSet: aSet! !


!Collection class methodsFor: 'instance creation'!
newLarge

	^self new: 100! !


!Interface commentStamp: '<historical>' prior: 0!
An Interface is an abstract Type, unlike Class which is a concrete Type. An interface specifies a set of messages that an object of any class implementing it would respond to. Therefore, it is orthogonal to Class, which propagates the implementation of a message to its instances. In other words, an interface specifies which messages an object will execute, where a class specifies how those messages will be executed.

For a more comprehensive explanation and a tutorial, look at the 'documentation' protocol (on the class side) !

!Interface class methodsFor: 'defaults'!
defaultClassName
	"This method is called for the purpose of generating a 'real' class from an interface."

	^(self name, 'Implementation') asSymbol! !

!Interface class methodsFor: 'defaults'!
defaultClassification

	^(self name, ' implementation') asSymbol! !

!Interface class methodsFor: 'defaults'!
defaultInterfaceName
	"This method is called for the purpose of generating an interface from a 'real' class.
	Since I am an interface, reaching this method is probably an error."
	
	^self error: 'I am an interface; you should not create an inteface for me!!'! !

!Interface class methodsFor: 'defaults'!
selectorForImplementation
	"The selector to be embeded within any method of an Interface"

	^#implementorsResponsibility! !

!Interface class methodsFor: 'defaults'!
selectorForStubbedImplementation
	"This selector is embeded as a stub within a method as initial implementation for an Interface"

	^#shouldImplementFor:! !

!Interface class methodsFor: 'testing'!
extends: anInterface

	^self ~~ anInterface and:
	[self repertoire includesAll: anInterface repertoire]! !

!Interface class methodsFor: 'testing'!
hasParents
	"A simple interface is an orphan"

	^self parents notEmpty! !

!Interface class methodsFor: 'testing'!
isEmbodiedIn: anObject

	^anObject conformsTo: self! !

!Interface class methodsFor: 'testing'!
isEmptyInterface

	^self repertoire isEmpty! !

!Interface class methodsFor: 'testing'!
isEquivalentTo: anInterface

	^self repertoire consistsOf: anInterface repertoire! !

!Interface class methodsFor: 'testing'!
isExtended
	"Note: not using 'self extendingInterfaces notEmpty' for speed"

	^self home allInterfaces contains: [:each | self isExtendedBy: each]! !

!Interface class methodsFor: 'testing'!
isExtendedBy: anInterface

	^anInterface extends: self! !

!Interface class methodsFor: 'testing'!
isExtending

	^self home allInterfaces contains: [:each | self extends: each]! !

!Interface class methodsFor: 'testing'!
isImplementedBy: aClass
	"Does <aClass> directly implement all of my repertoire?"

	^aClass repertoireImplemented includesAll: self repertoire! !

!Interface class methodsFor: 'testing'!
isInterface
	"All subclass are considered as interfeces, excluding the superclass - Interface."

	^self ~~ Interface! !

!Interface class methodsFor: 'testing'!
isOrphan
	"A composite interface has parents"
	
	^self hasParents not! !

!Interface class methodsFor: 'testing'!
isUnderstoodBy: aClass
	"Can <aClass> understand all of <anInterface> repertoire?"

	^aClass repertoire includesAll: self repertoire! !

!Interface class methodsFor: 'testing'!
mustBeImplemented
	"Indicating the way I should be implemented by a class. 
	Consider the case of #hash and #=. How can we indicate that if a class implements one, 
	it should implement the other? (By overriding this method to return true.)
	The default is false, which means it is sufficient that I am understood by the implementing class."

	^false! !

!Interface class methodsFor: 'code generation'!
createMethod: selector from: aClass

	| source category |
	source := self methodSourceFor: selector from: aClass.
	category := aClass isNil
		ifTrue: [#repertoire]
		ifFalse: [aClass organization categoryOfElement: selector].
	self compile: source classified: category! !

!Interface class methodsFor: 'code generation'!
createMethods: selectors

	self createMethods: selectors from: nil! !

!Interface class methodsFor: 'code generation'!
createMethods: selectors from: aClass

	selectors do: [:each | self createMethod: each from: aClass]! !

!Interface class methodsFor: 'code generation'!
createStubbedMethodFor: selector from: aClass
	"Create a stub method implementation for a selector in <aClass> on behalf of me."

	| interfaceOwningSelector |
	interfaceOwningSelector := self ancestors 
		detect: [:each | each repertoire includes: selector] 
		ifNone: [self].
	aClass 
		compile: (self methodSourceFor: selector from: self)
		classified: (interfaceOwningSelector defaultClassification)! !

!Interface class methodsFor: 'code generation'!
implementationStringForInterface

	^String newLarge writeStream
		nextPutAll: '^self';
		space;
		nextPutAll: self selectorForStubbedImplementation asString;
		space;
		nextPutAll: self name asString;
		contents! !

!Interface class methodsFor: 'code generation'!
methodSourceFor: selector from: aClass

	^aClass isNil
		ifTrue: 
			[self
				methodSourceWithHeader: selector asSelectorStringWithArguments 
				comment: ''
				implementation: Class implementationStringForInterface]
		ifFalse:
			[self
				methodSourceWithHeader: (aClass>>selector) selectorWithArgumentsString 
				comment: (aClass commentFor: selector)
				implementation: aClass implementationStringForInterface]! !

!Interface class methodsFor: 'code generation'!
methodSourceWithHeader: selectorWithArgumentsString comment: commentString implementation: implementationString

	| writer |
	writer := String newLarge writeStream.
	writer nextPutAll: selectorWithArgumentsString trimSeparators.
	commentString notEmpty 
		ifTrue:
			[writer
				crtab; 
				nextPut: $";
				nextPutAll: commentString;
				nextPut: $"].
	writer
		cr; 
		crtab; 
		nextPutAll: implementationString.
	^writer contents! !

!Interface class methodsFor: 'class creation'!
asClass

	^self asClassNamed: self defaultClassName! !

!Interface class methodsFor: 'class creation'!
asClassNamed: aSymbol

	^self 
		asClassNamed: aSymbol 
		super: Object! !

!Interface class methodsFor: 'class creation' stamp: 'M.U 6/13/1999 23:22'!
asClassNamed: aSymbol super: aClass
	"SmallInterfaces: ##modified for Squeak -M.U. 6/23/1999 23:35"
	| defaultCategory |
	defaultCategory := InterfaceConfiguration current defaultInterfaceClassCategory.
	aClass isFixed 
		ifTrue:
			[^aClass
				subclass: aSymbol
				instanceVariableNames: ''
				classVariableNames: ''
				poolDictionaries: ''
				category: defaultCategory
				interfaces: self name asString].		
	^aClass isVariable 
		ifTrue:
			[aClass isBits
				ifTrue:
					[aClass
						variableByteSubclass: aSymbol
						instanceVariableNames: ''
						classVariableNames: ''
						poolDictionaries: ''
						category: defaultCategory
						interfaces: self name asString]
				ifFalse:
					[aClass  
						variableSubclass: aSymbol
						instanceVariableNames: ''
						classVariableNames: ''
						poolDictionaries: ''
						category: defaultCategory
						interfaces: self name asString]]
		ifFalse: [self error: 'Sorry, can not handle this type of class.']! !

!Interface class methodsFor: 'accessing'!
allRelevantClassesAndInterfaces

	^(Set with: self)
		addAll: self extendedInterfaces;
		addAll: self extenders;
		addAll: self understanders;
		yourself! !

!Interface class methodsFor: 'accessing'!
configuration
	"<Interface configuration 
		enforceNonEmptyInterfaces: true;
		removeOnlyStubbedImplementations: true>"

	^InterfaceConfiguration current! !

!Interface class methodsFor: 'accessing'!
home

	^InterfaceHome current! !

!Interface class methodsFor: 'accessing'!
repertoire
	"Return all selectors for the messages I specify"
	
	^self selectors! !

!Interface class methodsFor: 'accessing-classes'!
implementingClasses

	self isEmptyInterface ifTrue: [^Set new].
	^self environment allNonInterfaceClasses select: [:each | each implements: self]! !

!Interface class methodsFor: 'accessing-classes'!
implementors

	^self implementingClasses! !

!Interface class methodsFor: 'accessing-classes'!
understanders

	^self understandingClasses! !

!Interface class methodsFor: 'accessing-classes'!
understandingClasses

	self isEmptyInterface ifTrue: [^Set new].
	^self environment allNonInterfaceClasses select: [:each | each understands: self]! !

!Interface class methodsFor: 'documentation'!
anOntologyOfInterfacesForSmalltalk4

"Each interface specifies a set of messages, which together constitutes its Repertoire.
Repertoires are not mutually exclusive; a message can be part of many repertoires.

Interfaces come in heterarchies, so that one interface can be declared as being a composite of other interfaces. A composite interface is an interface that extends other interfaces; it inherits message declarations from its extended interfaces, and may add additional declarations of its own. It is also referred to as an extending interface. These interface classifications are not mutually exclusive; an interface can be extended and extending at the same time.

At the top of the heterarchy are root interfaces, which are parentless interfaces; they extend no other interfaces. At the bottom of the heterarchy are the leaf interfaces, which are childless interfaces; no other interfaces extend them. These interface classifications also are not mutually exclusive. Consider the case where an environment contains a single interface; that singleton interface is both a root and a leaf at the same time.

An interface with no repertoire is referred to as an empty interface, and is considered to be an illegitimate interface.

Within a universe, interfaces forms a-cyclical directed graphs that are not necessarily connected.


A class is an understander of an interface (or understanding class) if it can respond to all messages of the interface's repertoire. A class can understand many interfaces, and an interface can be understood by many classes.

A class is an implementor of an interface (or implementing class) if it itself implements the entire interface's repertoire. Thus, being an implementor implies being an understander. A class can implement many interfaces, and an interface can be implemented by many classes."! !

!Interface class methodsFor: 'documentation'!
interfacesAndSmalltalk3

"Interfaces are not about static typing. In principle, they are merely about typing. More specifically, they can be used to solely specify a behavior, detached from data.
The concept of interfaces is central to object-oriented methodologies. It is commonly referred to as Type. The interface of an object is determined by the set of all message sends that an object can respond to. It is therefore orthogonal to the concept of a class that propagates the implementation of a message to its instances. In other words, an interface specifies which messages an object will execute, where a class specifies how those messages will be executed.

Some OO languages have Interface and Class as two distinct concepts. For example, Java reifies both to some extent and includes syntax for defining and implementing interfaces, while Microsoft COM and OMG CORBA both have their own software object interface definition languages (IDLs).

In Smalltalk however, the interfaces of an object are implicit and folded into its class implementation. This is not to say that interfaces in Smalltalk can not be harvested and become tangible, first-class objects. On the contrary, this is exactly what SmallInterfaces sets to achieve - the reification of interfaces in Smalltalk.

For a dynamically typed language like Smalltalk it is sufficient for a message declaration to specify (implicitly) the number of arguments. That is what SmallInterfaces does. However, another scheme could be chosen where the input arguments would be specified together with their order, type, and associated constraints. It would make sense then to specify the return value as well."! !

!Interface class methodsFor: 'documentation'!
tutorial

"I guess the biggest question everybody has is: 
	'How would I use one of 'them interfaces in Smalltalk?'

Within the context of Smalltalk, interfaces can be useful in three major areas: 
	Design, Documentation, and Exploration.
	
For each aspect, see the corresponding tutorial.

Note that all interfaces are classes, and as such can be browsed and modified using a generic browser. So once you have created an interface, you can use a generic browser to add some methods, and/or remove other methods."! !

!Interface class methodsFor: 'documentation'!
tutorialDesigning

"The concept of interfaces can help us do a better job with using Responsibility Driven Design by facilitating a higher level of abstraction than that of a class. The gist of Responsibility Driven Design is that when one designs an object (in the context of a society of objects), one wants to concentrate on what services an object needs to offer to its clients.  What we are really after is figuring out what are the pure 'working relationships' an object has within its society. We do not care about *how* the object is going to work it out, nor what state it needs to maintain in order to do so.  

Each service an object is contracted to supply, or said differently - each role it plays, is embodied within an interface.

So, designing using interfaces can be a mind liberating experience. With interfaces one can better concentrate on the question: 'What are the responsibilities of a given object?' in terms of: 'What should be its repertoire?' 

Designing is then broken down into searching for the answer to: 'What messages this and that are supposed to communicate and understand in order to get a certain functionality/aspect accomplished?'

If we follow this design mode, we have: 
	Responsibilities beget Roles, 
		Roles beget Interfaces,  
			Interfaces beget Objects.


With that in mind, let us put this theory into practice using an example.  

Say you have a domain where you need the ability to price some objects.  Some objects have no price, some have a fixed price, and some have a dynamic price.  The dynamic price may depend on various factors such as time and locale.  Also, that price needs to be quoted in a parameterized way, such as: in a currency, in goods (as in: 'I'll give you three loaves of bread for two of these'), or in services (as in: 'will be president for food').  

An important aspect of these objects is that they can be priced; they are priceable (clink, clink...). Some of these objects have the capability to compute their price; others would use a helper pricer to do the job, and others yet, might do one or the other - depending on the context. What they all have in common is that they all need to understand (and respond to) the following group of messages:
	price
	priceAsOf: aTemporal   (such as Date, Timestamp, etc.)
	priceAsOf: aTemporal quantifyUsing: aTradable   (such as Money, Product, WorkService)
	defaultTemporal
	defaultTradable
	pricer

This group of messages, this repertoire, has semantic meaning on its own, and as such it deserves to be a first class object. We call such reification - an interface. And the above repertoire defines the Priceable interface. From that point on, we no longer need to say: 'Money or Product or WorkService or whatever' - we can refer to those entities as Priceables.

As an exercise, you might want to try and define the Pricer interface.  Note that a pricer for: 5 cubic miles of irrigation water in the Sahara for the summer of 1999 might have very little in common with a pricer for: 10,000 IBM stocks on the New York Exchange for 1/1/2000.
If you still got energy, go a head and define the Tradable and Temporal interfaces. Note that the price answered is a Quantifiable. Define that too.

Can you start to see the advantages of 'thinking' in interfaces?

When you are done with this little design you end up with capturing the core of your business. Furthermore, there is enough content in this design to facilitate some simulations of business scenarios, and by doing so, validating your understanding of the problem at hand.

Maybe you can also imagine that the actual classes that will be used to implement this design would cross hierarchies. For example, some objects' prices will be date-specific, some location-specific, some will be time & location specific, some will have to consider all factors or none - depending on the context when they are asked (like by whom).

Now you can use SmallInterfaces to make the first step in implementing this design - declaring those interfaces.
Using SmallInterfaces you can create interfaces programmatically by one of three ways:
	1. define the interface and its methods directly
	2. define the interface and its methods from a group of interfaces
	3. define the interface and its methods from a class

Using the Priceable interface as an example for the first way, we would execute:
	<Interface 
		newNamed: #Priceable
		withSelectors: #(price priceAsOf: priceAsOf:quantifyUsing: defaultTemporal defaultTradable pricer)>

Using an example from the attached ToyInterfaces package to illustrate the second way, we would execute:
	<Interface 
		newNamed: #ReadableWritable
		extending: 'Readable Writable'
		additionalSelectors: #()>

Now assuming you want to use Magnitude as a template for the Quantifiable interface, you could use the third way and execute:
	<Magnitude asInterfaceNamed: #Quantifiable> 
or:
	<Interface 
		newNamed: #Quantifiable 
		from: Magnitude>

Remember that all interfaces are classes, and can be browsed and modified using the generic browser. So, for example, after creating Quantifiable from Magnitude, you might want to remove some methods, and/or add some others.

Now you are ready for the next step - implementing some classes based on those interfaces.
Assuming you had Priceable & Quantifiable in mind, and you wanted to create Price & Quantity, you would execute something like:
	<Priceable asClassNamed: #Price super: MyDomainObject>
and:
	<Quantifiable asClassNamed: #Quantity>

The Price & Quantity classes would now hold stubbed method implementations for Priceable & Quantifiable repertoires (including comments, if you had any).


All the above operations and more are easily performed using the Interface Browser GUI."! !

!Interface class methodsFor: 'documentation'!
tutorialDocumenting

"Using interfaces we can write a better self-documenting code, since we have a higher level of abstraction at our disposal. We can use interfaces to make the implicit explicit, thus helping the original design surface and stay visible as the code evolves. Their presence should help providing direction for the refactoring process. 

Consider the following implementation snippet for the example in the design section:

WorkService>>priceAsOf: aTemporal quantifyUsing: aTradable		
	^self pricer 
		price: self
		in: self location
		asOf: aTemporal
		quotingIn: aTradable

Notice that pricer, aTemporal, aTradable, and possibly location, represent interfaces. The actual possible objects that can occupy each slot are not necessarily sharing the same hierarchy!!

Now consider how the very same code snippet would look without 'thinking in interfaces':

WorkService>>priceAsOf: aDateOrTimeOrTimestamp quantifyUsing: aMoneyOrProductOrWorkService		
	^self pricer 
		price: self
		in: self location
		asOf: aDateOrTimeOrTimestamp
		quotingIn: MoneyOrProductOrWorkService

Which version is better at self-documenting?


Interfaces can also be used in design validation. After specifying a #requiredInterfaces method on the class side of aClass, we now can use <aClass implementsRequiredInterfaces> in our code, like in a testcase: 
	<self should: [someObject class implementsRequiredInterfaces]>


A more explicit way of indicating the original design, is a variation of the #isSomething usage.
For example, all classes that implement Priceable will implement isPriceable to return true, while their superclasses will implement it to return false. Now we can have phrases such as:
	<anObject isPriceable
		ifTrue: [self charge: aCustomer for: anObject]
		ifFalse: [self giveAway: anObject to: aCustomer]>


Also, we can now sprinkle in our code statements like:
	<groupOfObjectsWhichSupposadlyAreKeyable do:
		[:each | 
		(each conformsTo: Keyable)
  			ifTrue: [each at: someplaceSafe put: somethingGood]
				ifFalse: [self giveMe: somethingGood]]>


Note that SmallInterfaces can automate some of these schemes, but does not."! !

!Interface class methodsFor: 'documentation'!
tutorialExploring

"Interfaces can give us another mental navigation tool while browsing the environment. My contention is that if interfaces had been more explicit in Smalltalk then one could have used them to learn a Smalltalk environment faster.
Following are a few examples taken from the VisualWorks environment to illustrate how interfaces could be used in system exploration.

VisualWorks has Model which has a specialized implementation of the Observable interface found in Object. Now let's say you want to find out if the environment has a specialized Observable collection as well. You look and you don't seem to see one under the Model hierarchy. So you might want to create an Observable interface with #myDependents: and #myDependents as its repertoire and search for implementors of Observable. 
To create an Observable interface you would execute:
	<Interface
	newNamed: # Observable
	withSelectors: #(#myDependents: #myDependents)>

To look for its implementors you would execute:
	<Observable implementingClasses> 
Depending on your environment the result would be something like:
	{Object TableAdaptor TwoDList Model WidgetWrapper List ScrollWrapper WeakArray}.
Notice List and WeakArray - they might be what you were looking for. Notice the others too - if you are one of the curious kinds, it might be interesting for you to try and figure why the others have a specialized implementation of the Observable interface.

You can now refine your Observable interface by adding other messages you think are integral to it, and use it as a template to create other observable objects. For example, how about implementing an observable process: one that has dependents who can be notified when it is completed its task (like Promise or Future for asynchronous messaging). Such a class would probably implement a Runnable interface as well...


Another example is related to extending the environment.

If you happened to add your own extensions to base classes you probably extended Dictionary as well. When doing so, did you think it might be useful to add the same extension to KeyedCollection as well?  If not, why? After all, KeyedCollection and Dictionary are both keyable...

A similar connection exists between SequenceableCollection and Stream, especially String and Stream."! !

!Interface class methodsFor: 'documentation'!
whatCanYouDoWithSmallInterfaces5

"1. Declare an interface and specify its behavior. This can be done in three distinct ways:
	- Directly, by specifying its name and selectors. (Look under the ''interface creation'' protocol under Interface.)
	- By composing from other interfaces.
	- By converting a class as a template (Look at the various asInterface* methods under Class.)

2. Declare a class as implementing one or more interfaces. This can be done in two distinct ways:
	- Directly, by adding a 'interfaces: stringOfInterfaceNames' to the class definition. 
	  (Look under the 'compiling' protocols under Class.)
	- By converting an interface to a class (Look at the various as Class* methods under Interface.)
	Both methods will create stubbed methods as necessary on behalf of the implemented interface(s)

3. Given a class, you can ask: 
	- What interfaces does it implement?

4. Given an interface, you can ask: 
	- Which classes understand it? 
	- Which classes implement it?

5. Given an interface, you can ask: 
	- Which interfaces extend it? 
	- Which interfaces it is extending?

6. Given a class and an interface, answer whether the class implements the interface.


Other features and important considerations:

Right now, a class' repertoire is considered to be its instance side repertoire only. A future implementation will separate the instance side repertoire and the class side (metaclass) repertoire as two distinct interfaces. This would be done together with reifying Repertoire.

The classes <--> interfaces relationships as well as interfaces <--> interfaces relationships are of a dynamic nature. This is to say that the web of relationships is always inferred from the actual composition of classes and interfaces every time a query is attempted. This is neat, but also very inefficient, especially when a query for all understanding classes is executed for an interface. Therefore, a caching scheme was implemented in RepertoireHome. As of now, the cache has to be invalidated manually.

When a class is added/changed/removed to/from the environment, all relevant interfaces are immediately affected by the event (causal connection). This is a byproduct of the dynamic relationship inference.

Ideally, when an interface is added/changed/removed to/from the environment, all relevant classes and interfaces should be immediately affected by the event (causal connection).
This ideal is only halfway implemented. For example, existing stubbed methods can be removed (configurable) when a class declares it understands/implements a different set of interfaces. 

Currently, the notion that an interface is a composite is implicit; when a new interface is composed from other interfaces, the repertoires of these interfaces are copied over. 

An empty interface (with no repertoire) is considered to be an illegitimate interface, and an attempt is made to prevent such interfaces from being created. This feature is configured via a flag in InterfaceConfiguration that can be changed. (InterfaceConfiguration contains other flags that can be configured by the user.)"! !

!Interface class methodsFor: 'documentation'!
whatIsAnInterface2

" An interface is an abstract type, unlike class, which is a concrete type. An interface specifies a set of messages that an object of any class implementing it would respond to. Therefore, it is orthogonal to class, which propagates the implementation of a message to its instances. 

Said differently, an interface specifies which messages an object will execute but it has no method implementations for those messages, where a class specifies how those messages will be executed by specifying method implementations for those messages.

Each interface specifies a set of messages, which together constitutes its repertoire. In turn, each message declaration specifies the message's name, and its arguments. For various languages, specifying the arguments for a message can mean different things, and there are many opinions and debates with regard to this issue."! !

!Interface class methodsFor: 'documentation'!
whyShouldYouBotherWithInterfaces1

"In the realm of domain analysis, the use of roles (also known as facets) has emerged as an important technique for classifying the features of objects. Roles reflect the various aspects of the object they describe, and the different roles that an object may play in relationship to other objects. More so, the assignment of responsibilities to an object depends on the role(s) it plays in a system of objects. 

Roles serve as an increasingly important metaphor for communicating object-oriented software designs and recognition of their importance has grown in recent years. For example, the codification of object-oriented software design knowledge in design patterns is founded in part on the metaphor of roles. Software design patterns describe reusable collaborations between design elements. Each design element plays an identifiable role with well-defined responsibilities.

Now, a design process and a programming language work well together when there is support and clean translation from the design process conceptual units to the programming language abstraction and composition mechanisms. An interface is the programming language mechanism that maps the design process role concept. 

The mental process that leads us from design to implementation can be summarized as:
Responsibilities beget Roles, 
Roles beget Interfaces,  
Interfaces beget Objects.

So interfaces are a very basic mechanism for thinking in terms of objects; they both define and organize the services objects provide. This is why designing good interfaces for objects becomes such an important endeavor when building applications using objects. "! !

!Interface class methodsFor: 'accessing-extending'!
children
	"Return my children, which are the interfaces immidiately extending me."

	| family children |
	family := self extenders.
	family isEmpty ifTrue: [^family].
		"now gradually trim the family's youngest generation, until only 
		the oldest generation remains. these are my immediate children."
	[children := Interface consolidate: family.
	family removeAll: children.
	family notEmpty] whileTrue.
	^children! !

!Interface class methodsFor: 'accessing-extending'!
descendants

	^self progeny! !

!Interface class methodsFor: 'accessing-extending'!
extenders
	"Return all intefaces which extend me"

	^self extendingInterfaces! !

!Interface class methodsFor: 'accessing-extending'!
extendingInterfaces
	"Return all intefaces which extend me directly or indirectly.
	In other words: all (composite) interfaces for which I am a progenator."

	self isEmptyInterface ifTrue: [^Set new].
	^(self home allInterfaces select: 
		[:each | each extends: self]) reject: 
			[:each | self isEquivalentTo: each]	"remove circularities"! !

!Interface class methodsFor: 'accessing-extending'!
progeny
	"Return all interfaces which extend me (in bredth-first order).
	In other words: the branches of my 'family tree' eminating from me."

	| family children descendants |
	family := self extenders.
		"now put an order within this family; my children first, their children after ..."
	descendants := OrderedCollection new: family size.
	[children := Interface consolidate: family.	
	descendants addAll: children.
	family removeAll: children.
	family notEmpty] whileTrue.
	^descendants reversed! !

!Interface class methodsFor: 'interface creation' stamp: 'M.U 6/16/1999 00:11'!
discardExistingInterfacesNottIn: interfaces
	"SmallInterfaces: ##modified for Squeak -M.U. 6/23/1999 23:35  bug?"
	| interfacesToDiscard | 
	interfacesToDiscard := self implementedInterfaces - interfaces.
	interfacesToDiscard remove: self ifAbsent:[].		"we do not want to unimplement the reciever's addtions"
	self unimplementInterfaces: interfacesToDiscard.! !

!Interface class methodsFor: 'interface creation'!
newNamed: aSymbol 

	"self isPrivateMethod."
	"SmallInterfaces: ##modified for Squeak -M.U. 6/23/1999 23:35"

	self ~~ Interface 
		ifTrue: [self error: 'an interface must be a direct subclass of Interface!!!!'].
	(self home includesInterfaceNamed: aSymbol) 
		ifTrue: [^self error: aSymbol asString, ' interface already exists!!!!'].
	^self 
		subclass: aSymbol
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: InterfaceConfiguration current defaultInterfaceClassCategory "M.U. 6/23/1999 23:35"
		interfaces: ''! !

!Interface class methodsFor: 'interface creation'!
newNamed: aSymbol extending: stringOfInterfaces additionalSelectors: selectors

	| interface |
	interface := self newNamed: aSymbol.
	interface extendInterfaces: (Interface interfacesFromString: stringOfInterfaces).
	interface createMethods: selectors.
	^interface! !

!Interface class methodsFor: 'interface creation'!
newNamed: aSymbol from: aClass

	^self 
		newNamed: aSymbol 
		withSelectors: aClass selectors 
		from: aClass! !

!Interface class methodsFor: 'interface creation'!
newNamed: aSymbol withSelectors: selectors

	(selectors isEmpty and:
	[self configuration enforceNonEmptyInterfaces])
		ifTrue: [^self error: 'can not create an empty interface!!'].

	^(self newNamed: aSymbol) createMethods: selectors! !

!Interface class methodsFor: 'interface creation' stamp: 'M.U 6/13/1999 23:39'!
newNamed: aSymbol withSelectors: selectors from: aClass
	"SmallInterfaces: ##modified for Squeak -M.U. 6/23/1999 23:35 bug?"
	(selectors isEmpty and:
	[self configuration enforceNonEmptyInterfaces])
		ifTrue: [^self error: 'can not create an empty interface!!'].

	^(self newNamed: aSymbol)
		createMethods: selectors 
		from: aClass! !

!Interface class methodsFor: 'extending'!
extendInterface: anInterface
	"SmallInterfaces: ##modified for Squeak -M.U. 6/23/1999 23:35"

	| classification |
	anInterface repertoire do: 
		[:each | 
		classification := anInterface organization categoryOfElement: each.
		(classification == #repertoire or:
		[(self environment hasClassNamed: classification) not])
			ifTrue: [classification := anInterface name].
		self 
			compile: (anInterface sourceCodeAt: each)
			classified: classification]! !

!Interface class methodsFor: 'extending'!
extendInterfaces: interfaces 

	self unimplementInterfaces: (self extendedInterfaces - interfaces).
	(Interface consolidate: interfaces) do: [:each | self extendInterface: each]! !

!Interface class methodsFor: 'extending'!
implementInterfaces: interfaces 

	self extendInterfaces: interfaces! !

!Interface class methodsFor: 'extending'!
unimplementInterfaces: interfaces

	interfaces do: [:each | self unimplementInterface: each]! !

!Interface class methodsFor: 'interface calculus'!
& anInterface

	^self intersectionWith: anInterface! !

!Interface class methodsFor: 'interface calculus'!
+ anInterface

	^self unionWith: anInterface! !

!Interface class methodsFor: 'interface calculus'!
-  anInterface

	^self differenceFrom: anInterface! !

!Interface class methodsFor: 'interface calculus'!
differenceFrom: anInterface

	| repertoire interface |
	repertoire := self repertoire reject: [:each| anInterface repertoire includes: each].
	interface := (self home interfaceWithRepertoire: repertoire) 
		ifNil: 
			[Interface 
				newNamed: (self name, 'Minus', anInterface name) asSymbol 
				withSelectors: repertoire].
	^interface! !

!Interface class methodsFor: 'interface calculus'!
intersectionWith: anInterface

	| repertoire interface |
	repertoire := self repertoire & anInterface repertoire.
	interface := (self home interfaceWithRepertoire: repertoire) 
		ifNil: 
			[Interface 
				newNamed: (self name, 'IntersectionWith', anInterface name) asSymbol 
				withSelectors: repertoire].
	^interface! !

!Interface class methodsFor: 'interface calculus'!
unionWith: anInterface

	| repertoire interface |
	repertoire := self repertoire + anInterface repertoire.
	interface := (self home interfaceWithRepertoire: repertoire) 
		ifNil: 
			[Interface 
				newNamed: (self name, 'Plus', anInterface name) asSymbol 
				withSelectors: repertoire].
	^interface! !

!Interface class methodsFor: 'querying'!
methodsImplementedBy: aClass

	^self repertoire & aClass repertoireImplemented! !

!Interface class methodsFor: 'querying'!
methodsNotImplementedBy: aClass

	^self repertoire - aClass repertoireImplemented! !

!Interface class methodsFor: 'querying'!
methodsNotUnderstoodBy: aClass

	^self repertoire - aClass repertoire! !

!Interface class methodsFor: 'querying'!
methodsStubbedIn: aClass

	^self repertoire & (aClass whichSelectorsReferTo: self selectorForStubbedImplementation)! !

!Interface class methodsFor: 'subclass creation'!
subclass: interfaceName
	instanceVariableNames: stringOfInstVars
	classVariableNames: stringOfClassVars
	poolDictionaries: stringOfPoolNames
	category: category
 	interfaces: stringOfInterfaces
	"Create or modify an interface so it would adhere to the declared Interfaces."

	| interface |
	interface := self
		subclass: interfaceName
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: category.
	interface implementInterfacesNamed: stringOfInterfaces.		
	^interface! !

!Interface class methodsFor: 'subclass creation'!
variableByteSubclass: interfaceName
	instanceVariableNames: stringOfInstVars
	classVariableNames: stringOfClassVars
	poolDictionaries: stringOfPoolNames
	category: category
 	interfaces: stringOfInterfaces
	"Create or modify an interface so it would adhere to the declared Interfaces.
	Note: since an interface must be a subclass"

	^self
		subclass: interfaceName
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: category
 		interfaces: stringOfInterfaces! !

!Interface class methodsFor: 'subclass creation'!
variableSubclass: interfaceName
	instanceVariableNames: stringOfInstVars
	classVariableNames: stringOfClassVars
	poolDictionaries: stringOfPoolNames
	category: category
 	interfaces: stringOfInterfaces
	"Create or modify an interface so it would adhere to the declared Interfaces."

	^self
		subclass: interfaceName
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: category
 		interfaces: stringOfInterfaces! !

!Interface class methodsFor: 'utilities'!
consolidate: interfaces
	"out of <interfaces>, return the minimal descriptive set.
	mostly, these are the interfaces which are not extended by any of the others."

	^interfaces select: [:each | (interfaces contains: [:interface | interface extends: each]) not]! !

!Interface class methodsFor: 'utilities'!
interfacesFromString: stringOfInterfaces

	^((stringOfInterfaces subStrings collect: 
		[:each | each asClass]) select: 
			[:each | each notNil]) select: 
				[:each | each isInterface]! !

!Interface class methodsFor: 'errors'!
basicNew

	self error: 'I am an Interface. I can not be instantiated!!'! !

!Interface class methodsFor: 'errors'!
implementorsResponsibility
	"Besides being an indicator, this method is envoked via: 'anObject shouldImplementFor: anInterface'.
	As a consequence, this message sets up a framework for the behavior of the interface's implementors."

	self error: 'My implementing class should have overridden one of my messages.'


"to facilitate laissez faire programming, one implementation could be:
	1. open an editor on the calling method (allow the user to abort).
	2. accept the source and copile it in the original sending class.
	3. continue execution (restart?)"! !

!Interface class methodsFor: 'errors'!
new

	self error: 'I am an Interface. I can not be instantiated!!'! !

!Interface class methodsFor: 'printing'!
ancestorsString

	| writer ancestors  |
	writer := String newLarge writeStream.
	(ancestors := self ancestors) notEmpty
		ifTrue:
			[writer 
				crtab; 
				nextPutAll: 'ancestors: {'.
			ancestors do: [:each | writer nextPutAll: each name asString; space].
			writer 
				skip: -1; 
				nextPutAll: '}'].
	^writer contents! !

!Interface class methodsFor: 'printing'!
definition

	| writer extendedInterfacesSelector extendedInterfaces |
	self == Interface ifTrue: [^super definition].
	
	writer := String newLarge writeStream.
	writer
		nextPutAll: super definition;
		crtab;
		nextPutAll: 'interfaces: ';
		nextPut: $'.
	extendedInterfacesSelector := self configuration selectorForInterfaceInheritance.
	extendedInterfaces := (self perform: extendedInterfacesSelector) asSortedCollection: Class sortBlock.
	extendedInterfaces do: [:each | writer nextPutAll: each name asString; space].
	writer nextPut: $'.
	^writer contents! !

!Interface class methodsFor: 'printing'!
definitionWithInterfaces

	^self definition! !

!Interface class methodsFor: 'printing'!
familyString

	^String newLarge writeStream
		nextPutAll: self name asString;
		nextPutAll: self ancestorsString;
		nextPutAll: self progenyString;
		contents! !

!Interface class methodsFor: 'printing'!
progenyString

	| writer progeny |
	writer := String newLarge writeStream.
	(progeny := self progeny) notEmpty
		ifTrue:
			[writer 
				crtab; 
				nextPutAll: 'progeny: {'.
			progeny do: [:each | writer nextPutAll: each name asString; space].
			writer 
				skip: -1; 
				nextPutAll: '}'].
	^writer contents! !

!Interface class methodsFor: 'accessing-extended'!
ancestors
	"Return all interfaces which I extend (in bredth-first order).
	In other words: the lineage chain from the roots of my 'family tree'."

	| family elders ancestors |
	family := self extendedInterfaces.
		"now put an order within this family; oldest generation first, youngen last..."
	ancestors := OrderedCollection new: family size.
	elders := family select: [:each | each isOrphan].	
	[ancestors addAll: elders.
	family removeAll: elders.
	family notEmpty] whileTrue:
		[elders := family select: [:each | ancestors includesAny: each parents]].
	^ancestors! !

!Interface class methodsFor: 'accessing-extended'!
extendedInterfaces
	"Return all intefaces which I extend directly or indirectly.
	In other words: all my originating interfaces."

	self isEmptyInterface ifTrue: [^Set new].
	^(self home allNonEmptyInterfaces select: 
		[:each | self extends: each]) reject: 
			[:each | self isEquivalentTo: each]	"remove circularities"! !

!Interface class methodsFor: 'accessing-extended'!
extendedInterfacesMinimalSet

	^Interface consolidate: self extendedInterfaces! !

!Interface class methodsFor: 'accessing-extended'!
parents
	"Return my parents, which are the interfaces I immidiately extend.
	Note: a simple (root) interface is an orphan, while a composite 
	interface is a child of unlimitted number of parents."

	^self extendedInterfacesMinimalSet! !


!InterfaceConfiguration commentStamp: '<historical>' prior: 0!
InterfaceConfiguration is responsible for the system-wide behavior of interfaces.

The current configuration can be switched by either configuring the current singletone, or by replacing the current singletone with another configuration.


Instance Variables:
defaultInterfaceClassCategory			<String>    ... which indicates the interface default directory (M.U 6/22/1999 23:15)
enforceNonEmptyInterfaces			<Boolean>	... is an empty interface legal?
removeOnlyStubbedImplementations	<Boolean>	... when unimplementing an interface for a class
selectorForInterfaceInheritance		<Symbol>	... which interfaces should be shown in the definition string? (e.g. all extended?)
selectorForClassInterfaces			<Symbol>	... which interfaces should be shown in the definition string? (e.g. all understood?)

Class Instance Variables:

singleton	<InterfaceConfiguration>	holds the current InterfaceConfiguration.
!

!InterfaceConfiguration methodsFor: 'accessing'!
defaultInterfaceClassCategory
	"SmallInterfaces: ##added for Squeak -M.U. 6/23/1999 23:35"
	^defaultInterfaceClassCategory ifNil: [defaultInterfaceClassCategory := 'Interfaces']! !

!InterfaceConfiguration methodsFor: 'accessing'!
defaultInterfaceClassCategory: aString
	"SmallInterfaces: ##added for Squeak -M.U. 6/23/1999 23:35"
	defaultInterfaceClassCategory := aString! !

!InterfaceConfiguration methodsFor: 'accessing'!
enforceNonEmptyInterfaces

	^enforceNonEmptyInterfaces ifNil: [enforceNonEmptyInterfaces := true]! !

!InterfaceConfiguration methodsFor: 'accessing'!
enforceNonEmptyInterfaces: aBoolean

	enforceNonEmptyInterfaces := aBoolean! !

!InterfaceConfiguration methodsFor: 'accessing'!
removeOnlyStubbedImplementations

	^removeOnlyStubbedImplementations ifNil: [removeOnlyStubbedImplementations := true]! !

!InterfaceConfiguration methodsFor: 'accessing'!
removeOnlyStubbedImplementations: aBoolean

	removeOnlyStubbedImplementations := aBoolean! !

!InterfaceConfiguration methodsFor: 'accessing'!
selectorForClassInterfaces

	^selectorForClassInterfaces ifNil: [selectorForClassInterfaces := #understoodInterfacesMinimalSet]! !

!InterfaceConfiguration methodsFor: 'accessing'!
selectorForClassInterfaces: selectorSymbol

	| permittedSelectors |
	permittedSelectors := Class selectorsInCategory: #'interfaces'.
	(permittedSelectors includes: selectorSymbol) 
		ifTrue:  [selectorForClassInterfaces := selectorSymbol]
		ifFalse: [self error: 'selector must be one of: ',  permittedSelectors asArray printString]! !

!InterfaceConfiguration methodsFor: 'accessing'!
selectorForInterfaceInheritance

	^selectorForInterfaceInheritance ifNil: [selectorForInterfaceInheritance := #parents]! !

!InterfaceConfiguration methodsFor: 'accessing'!
selectorForInterfaceInheritance: selectorSymbol

	| permittedSelectors |
	permittedSelectors := Interface class selectorsInCategory: #'accessing-extended'.
	(permittedSelectors includes: selectorSymbol)
		ifTrue:  [selectorForInterfaceInheritance := selectorSymbol]
		ifFalse: [self error: 'selector must be one of: ',  permittedSelectors asArray printString]! !


!InterfaceConfiguration class methodsFor: 'class initialization'!
initialize
	"InterfaceConfiguration initialize."
	"SmallInterfaces: ##modified for Squeak -M.U. 6/23/1999 23:35"

! !

!InterfaceConfiguration class methodsFor: 'class initialization'!
obsolete
	"SmallInterfaces: ##modified for Squeak -M.U. 6/23/1999 23:35"
	self nuke.! !

!InterfaceConfiguration class methodsFor: 'instance creation'!
current

	^singleton ifNil: [singleton := super new]! !

!InterfaceConfiguration class methodsFor: 'instance creation'!
new

	^self current! !

!InterfaceConfiguration class methodsFor: 'instance creation'!
nuke

	singleton := nil! !


!InterfaceHome commentStamp: '<historical>' prior: 0!
InterfaceHome is the access point for all interfaces.
Its sole responsibility is to provide 'slice & dice' views on interfaces.

As of now it is a pseudo-repository. However, it has a hook to facilitate streaming in & out of interfaces.
This should be done via by implementing a different singltone access.


Class Instance Variables:

singleton	<InterfaceHome>	holds the current InterfaceHome.!

!InterfaceHome methodsFor: 'querying'!
allExtendedInterfaces

	^self allInterfaces select: [:each | each isExtended]! !

!InterfaceHome methodsFor: 'querying'!
allExtendingInterfaces

	^self allInterfaces select: [:each | each isExtending]! !

!InterfaceHome methodsFor: 'querying'!
allInterfaces

	^Interface subclasses asSet! !

!InterfaceHome methodsFor: 'querying'!
allNonEmptyInterfaces

	^self allInterfaces reject: [:each | each isEmptyInterface]! !

!InterfaceHome methodsFor: 'querying'!
childlessInterfaces

	^self leafInterfaces! !

!InterfaceHome methodsFor: 'querying'!
classesNotFullyImplemented

	| resultSet classes |
	resultSet := Set new.
	classes := self environment allNonInterfaceClasses.
	self allInterfaces do: 
		[:eachInterface | 
		resultSet addAll: (classes select:
			[:eachClass | (eachInterface methodsStubbedIn: eachClass) notEmpty])].
	^resultSet! !

!InterfaceHome methodsFor: 'querying'!
emptyInterfaces

	^self allInterfaces select: [:each | each isEmptyInterface]! !

!InterfaceHome methodsFor: 'querying'!
equivalentInterfaces
	"Return a collection of sets of interfaces having an equivalent repertoire"
	
	"SmallInterfaces: ##modified for Squeak -M.U. 6/23/1999 23:35"

	| collectionOfSetsOfEquivalentInterfaces interfaces  setOfEquivalentInterfaces |
	collectionOfSetsOfEquivalentInterfaces := OrderedCollection new.
	interfaces := self allInterfaces copy.
	self allInterfaces do: 
		[:each | 
		interfaces remove: each ifAbsent: [].
		setOfEquivalentInterfaces := interfaces select: [:anInterface | each isEquivalentTo: anInterface].
		setOfEquivalentInterfaces notEmpty
			ifTrue:
				[interfaces removeAll: setOfEquivalentInterfaces.
				setOfEquivalentInterfaces add: each. 	"...since it isn't included in yet"
				collectionOfSetsOfEquivalentInterfaces add: setOfEquivalentInterfaces]].
	^collectionOfSetsOfEquivalentInterfaces! !

!InterfaceHome methodsFor: 'querying'!
includesInterfaceNamed: aSymbol

	^self allInterfaces contains: [:each | each name == aSymbol]! !

!InterfaceHome methodsFor: 'querying'!
interfaceNamed: aSymbol

	^self allInterfaces 
		detect: [:each | each name == aSymbol] 
		ifNone: [nil]! !

!InterfaceHome methodsFor: 'querying'!
interfaceWithRepertoire: repertoire

	^self allInterfaces 
		detect: [:each | each repertoire consistsOf: repertoire]
		ifNone: [nil]! !

!InterfaceHome methodsFor: 'querying'!
interfacesWithRepertoire: repertoire

	^self allInterfaces select: [:each | each repertoire consistsOf: repertoire]! !

!InterfaceHome methodsFor: 'querying'!
leafInterfaces

	^Interface consolidate: self allInterfaces! !

!InterfaceHome methodsFor: 'querying'!
rootInterfaces

	^self rootsOfTheInterfaceWorld! !

!InterfaceHome methodsFor: 'querying'!
rootsOfTheInterfaceWorld

	^self allInterfaces select: [:each | each isOrphan]! !

!InterfaceHome methodsFor: 'actions'!
removeEmptyInterfaces

	self emptyInterfaces do: [:each | self environment removeClassNamed: each name]! !


!InterfaceHome class methodsFor: 'class initialization'!
obsolete

	self nuke! !

!InterfaceHome class methodsFor: 'instance creation'!
current

	^singleton ifNil: [singleton := super new]! !

!InterfaceHome class methodsFor: 'instance creation'!
new

	^self current! !

!InterfaceHome class methodsFor: 'instance creation'!
nuke

	singleton := nil! !


!Metaclass methodsFor: 'accessing'!
environment
	"SmallInterfaces: ##added for Squeak -M.U. 6/23/1999 23:35"
	^thisClass environment! !


!RepertoireHome commentStamp: '<historical>' prior: 0!
RepertoireHome is the access point for all repertoires.
Its sole responsibility is to maintain a cache of  class repertoires.
The cache is created upon load, and as of now it has to be invalidated manually.
The cache can be refreshed by executing: <RepertoireHome initialize>


Instance Variables:

classRepertoiresDictionary	<IdentityDictionary>	holds the class repertoires cache.
cacheRepertoires			<Boolean>			determines whether caching is on or off

Class Instance Variables:

singleton	<RepertoireHome>	holds the current RepertoireHome.!

!RepertoireHome methodsFor: 'initialize-release'!
connectToChanges
	ChangeSet addDependent: self! !

!RepertoireHome methodsFor: 'initialize-release'!
disconnectFromChanges
	ChangeSet removeDependent: self! !

!RepertoireHome methodsFor: 'initialize-release'!
initialize

	self 
		computeRepertoires;
		connectToChanges! !

!RepertoireHome methodsFor: 'initialize-release'!
release

	super release.
	self disconnectFromChanges.! !

!RepertoireHome methodsFor: 'initialize-release' stamp: 'M.U 6/16/1999 00:57'!
update: aChangedClass 
	"SmallInterfaces: ##added for Squeak -M.U. 6/23/1999 23:35"
	
	aChangedClass withAllSubclasses do: [:each | self clearEntryFor: each]! !

!RepertoireHome methodsFor: 'cache management'!
clearEntryFor: aBehavior

	aBehavior isInterface ifTrue: [^self].
	classRepertoiresDictionary 
		removeKey: aBehavior name 
		ifAbsent: [].! !

!RepertoireHome methodsFor: 'cache management'!
clearRepertoires

	classRepertoiresDictionary := IdentityDictionary new! !

!RepertoireHome methodsFor: 'cache management'!
computeRepertoires

	self clearRepertoires.
	self computeRepertoiresWithGuiFeedback.! !

!RepertoireHome methodsFor: 'cache management' stamp: 'M.U 6/13/1999 22:47'!
computeRepertoiresWithGuiFeedback

	"SmallInterfaces: ##modified for Squeak -M.U. 6/23/1999 23:35"
	| classes counter |
	classes := self environment allNonInterfaceClasses.
	counter := 0.
	'Caching repertoires for all classes...'
		displayProgressAt: Sensor cursorPoint
		from: 0
		to: classes size
		during: [:bar | classes do: 
				[:each | 
				self createEntryFor: each.
				counter := counter + 1.
				bar value: counter]]! !

!RepertoireHome methodsFor: 'cache management'!
createEntryFor: aBehavior 

	classRepertoiresDictionary 
		at: aBehavior name 
		put: aBehavior allSelectors! !

!RepertoireHome methodsFor: 'querying'!
repertoireFor: aBehavior

	^classRepertoiresDictionary 
		at: aBehavior name
		ifAbsentPut: [aBehavior allSelectors]! !


!RepertoireHome class methodsFor: 'class initialization'!
initialize
	"<self initialize>"

	self nuke.
	self current.! !

!RepertoireHome class methodsFor: 'class initialization'!
obsolete

	self nuke! !

!RepertoireHome class methodsFor: 'instance creation'!
current

	^singleton ifNil: [singleton := super new initialize]! !

!RepertoireHome class methodsFor: 'instance creation'!
new

	^self current! !

!RepertoireHome class methodsFor: 'instance creation'!
nuke

	singleton notNil ifTrue: [singleton release].
	singleton := nil.! !


!SequenceableCollection methodsFor: 'converting'!
writeStream
	"SmallInterfaces: ##added for Squeak -M.U. 6/23/1999 23:35"
	^WriteStream on: self! !

!SequenceableCollection methodsFor: 'testing'!
ends: aSequenceableCollection 
	"Answer whether the last elements of aSequenceableCollection are equal to the elements of the reciever."

	^self reverse starts: aSequenceableCollection reverse! !

!SequenceableCollection methodsFor: 'testing'!
endsWith: aSequenceableCollectionOrObject  
	"if aSequenceableCollectionOrObject is a <SequenceableCollection>, answer whether the 
	last elements of the receiver, respectively, are equal to the elements of the <SequenceableCollection>.
	if aSequenceableCollectionOrObject is any other kind of object, answer whether the 
	last element of the receiver equals to that <Object>."

	^aSequenceableCollectionOrObject ends: self! !

!SequenceableCollection methodsFor: 'testing'!
starts: aSequenceableCollection 
	"Answer whether the first elements of aSequenceableCollection are equal to the elements of the reciever.
	<'in' starts: 'in the beginning...' >"

	(self isEmpty or:
	[aSequenceableCollection size < self size]) ifTrue: [^false].
		
	1 to: self size do: [:each | (aSequenceableCollection at: each) = (self at: each) ifFalse: [^false]].
	^true! !


!CompiledMethod methodsFor: 'accessing'!
sourceString
	"Return the source code for the receiver."
	"SmallInterfaces: ##modified for Squeak -M.U. 6/23/1999 23:35"

	^self getSourceFromFile asString! !

!CompiledMethod methodsFor: 'printing'!
selectorWithArgumentsString

	| firstLine |
	self sourceString isEmpty ifTrue: [^self selector asSelectorStringWithArguments].
	
		"make the crudest attempt: assume the method header is all in the first line
		(like any good formatting practice would dictate...)"
	firstLine := self sourceString firstLine.
	^(firstLine subStrings includesAll: self selector keywords)
		ifTrue: [firstLine]
		ifFalse: [self selector asSelectorStringWithArguments]! !


!Set methodsFor: 'adding'!
, aCollection 
	"Answer a copy of the receiver concatenated with the argument, aCollection."
	
	^self copy
		addAll: aCollection asSet;
		yourself! !

!Set methodsFor: 'removing'!
- aSet
	"Answer those elements present in the receiver and absent from aSet."
	"SmallInterfaces: ##added for Squeak -M.U. 6/23/1999 23:35"
	^self reject: [ :i | aSet includes: i ]! !

!Set methodsFor: 'set operations'!
& aSet 
	"Set intersection"

	^self intersectionWith: aSet! !

!Set methodsFor: 'set operations'!
+ aCollection 
	"Set union"

	^self , aCollection! !

!Set methodsFor: 'set operations'!
intersectionWith: aSet
	"Intersection of two sets."

	^self select: [:each | aSet includes: each]! !

!Set methodsFor: 'set operations'!
intersectionWithSet: aSet
	"Return the elements in common with receiver and aSet as a set with one instance of each element.
	<#(1 2 3) asSet intersectionWithSet: #(2 3 4) asSet>"

	^(self size <= aSet size)
		ifTrue: [self select: [:each | aSet includes: each]]
		ifFalse: [aSet intersectionWithSet: self]! !


!Dictionary methodsFor: 'accessing'!
values
	"SmallInterfaces: ##added for Squeak -M.U. 6/23/1999 23:35"
	| values |
	values := OrderedCollection new: self size.
	self do: [:value | values add: value].
	^values! !

!Dictionary methodsFor: 'set operations'!
intersectionWithSet: aSet
	"Return the elements in common with receiver and aSet 
	as a set with one instance of each value in receiver that is equal to one in aSet"

	^self values asSet intersectionWithSet: aSet! !


!Stream class methodsFor: 'instance creation'!
newLarge

	^self on: self contentsSpecies newLarge! !


!String methodsFor: 'converting'!
asArrayOfSubstrings
		"Answer an array of substrings from the
		 receiver.  The receiver is divided into
		 substrings at the occurrences of one or
		 more space characters."

	| aStream answer index |
	answer := OrderedCollection new.
	aStream := ReadStream on: self.
	[aStream atEnd]
		whileFalse: [
			[aStream atEnd ifTrue: [^answer asArray].
			 aStream peek > (TextConstants at: #Space)]
				whileFalse: [aStream next].
			index := aStream position + 1.
			[aStream atEnd or: [aStream peek <= (TextConstants at: #Space)]]
				whileFalse: [aStream next].
			answer add:
				(self copyFrom: index to: aStream position)].
	^answer asArray! !

!String methodsFor: 'converting'!
asClass
	"Answer the class I designate."

	^self asSymbol asClass! !

!String methodsFor: 'converting'!
asSequenceableCollection: aChar 
	"Answer a Collection of lines in me. 
	The end-of-line character is aChar."
	"original in CharacterArray"

	| lines lastEOL |
	lines := OrderedCollection new.
	lastEOL := 0.
	1 to: self size do: 
		[:i | 
		(self at: i) = aChar
			ifTrue: 
				[lines addLast: (self copyFrom: lastEOL + 1 to: i - 1).
				lastEOL := i]].
		"deal with last line if not terminated"
	lastEOL = self size ifFalse: [lines addLast: (self copyFrom: lastEOL + 1 to: self size)].
	^lines! !

!String methodsFor: 'converting'!
asWords
	"Return a copy of receiver with a space inserted between 
	a lower case letter and a following upper case letter. 
	<'aVISACard' asWords>"
	"original in CharacterArray"

	| workStream lastWasLowerCase |
	workStream := (String new: self size * 2) writeStream.
	lastWasLowerCase := false.
	1 to: self size do: 
		[:each | 
		(self at: each) isUppercase	"bootstrap condition"	
			ifTrue: 
				[lastWasLowerCase
					ifTrue: [workStream space]
					ifFalse: [(each > 1 and: [(self at: each + 1) isLowercase]) ifTrue: [workStream space]].
				lastWasLowerCase := false]
			ifFalse: [lastWasLowerCase := true].
		workStream nextPut: (self at: each)].
	^workStream contents! !

!String methodsFor: 'converting'!
subStrings
	"Answer an array which contains the words in the receiver."

	^self asArrayOfSubstrings! !

!String methodsFor: 'converting'!
trimSeparators

	"Return a copy of the receiver that has leading and trailing separators removed."

	| size index |
	(size := self size) == 0 ifTrue: [^self].
	index := 1.
	[(self at: index) isSeparator] whileTrue: [
		index = size ifTrue: [^''].
		index := index + 1].
	[(self at: size) isSeparator] whileTrue: [
		index = size ifTrue: [^''].
		size := size - 1].
	^self copyFrom: index to: size! !

!String methodsFor: 'printing'!
firstLine

	^(self asSequenceableCollection: Character cr) first! !


!Symbol methodsFor: 'converting'!
asClass
	"Answer the class I designate. Return nil if no such class exists.
	<#String asClass>
	<'Array' asClass>
	<'foo' asClass>"

	^self environment 
		at: self  
		ifAbsent: [nil]! !

!Symbol methodsFor: 'converting'!
asSelectorStringWithArguments
	"<#at:put: asSelectorStringWithArguments>
	<#halt asSelectorStringWithArguments>
	<#@ asSelectorStringWithArguments>"
	
	"SmallInterfaces: ##modified for Squeak -M.U. 6/23/1999 23:35"

	| writer |
	self isUnary ifTrue: [^self asString].
	self isBinary ifTrue: [^self asString, ' anObject'].

	writer := WriteStream on: String newLarge.
	self keywords withIndexDo: 
		[:each :index | "M.U. 6/23/1999 23:35"
		writer 
			nextPutAll: each;
			nextPutAll: ' arg';
			nextPutAll: index printString;
			space].
	^writer contents! !

!Symbol methodsFor: 'testing'!
isBinary
	"if I am to be interpreted as a message selector, am I a binary method? (such as #<).
	<#@ isBinary>
	<#== isBinary>
	<#halt isBinary>
	<#at: isBinary>"
	"SmallInterfaces: ##modified for Squeak -M.U. 6/23/1999 23:35"
	^self numArgs = 1 and: [(self endsWith: ':') not] ! !

!Symbol methodsFor: 'testing'!
isUnary
	"if I am to be interpreted as a message selector, am I an unary method? (such as #class).
	<#@ isUnary>
	<#halt isUnary>
	<#at: isUnary>"

	^self numArgs = 0! !


!SystemDictionary methodsFor: 'querying'!
allNonInterfaceClasses
	"<self environment allNonInterfaceClasses>"

	^self allClasses reject: [:each | each isInterface]! !


!UndefinedObject class methodsFor: 'fileIn/out'!
methodsForUndefined: aString 
	"SmallInterfaces: ##added for Squeak -M.U. 6/23/1999 23:35"
	^super methodsFor: aString! !


InterfaceConfiguration initialize!
RepertoireHome initialize!
